  {-------------------------------------------------------------------------}
  {----------------------------- EDITWEBS ----------------------------------}

{*
 * EditWebs - NON-WYSIWYG web editor.
 * Copyright (C) 2005, 2006 Mat Sulr
 *
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}
  
unit hlavne;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ComCtrls, Buttons, StdCtrls, FileCtrl, CheckLst, Process, IniFiles,
  SynEdit, SynMemo, SynHighlighterHTML, SynHighlighterCss, SynHighlighterJava,
  SynHighlighterPHP, FileUtil, PrintersDlgs, Printers, SynEditHighlighter,
  ExtCtrls, ColorBox, ExtDlgs, LazJPEG, JwaWinBase,
  Nastav, Predlohy, Vkladat;


{$R editwebs.res}

type

  { TF }

  TF = class(TForm)
    Aplikacia: TApplicationProperties;
    btnObnovitSubory: TBitBtn;
    btnNacitatPaletu: TBitBtn;
    btnPoslednyPanel: TBitBtn;
    btnPrvyPanel: TBitBtn;
    btnVlozitFarbu: TBitBtn;
    btnVlozitEntitu: TBitBtn;
    btnVlozitZnak: TBitBtn;
    btnVlozitZoScriptov: TBitBtn;
    btnVlozitCSS: TBitBtn;
    btnCSSIdentifikator: TBitBtn;
    btnCSSTrieda: TBitBtn;
    btnCSSSelektor: TBitBtn;
    btnVlozitTagAtr: TBitBtn;
    btnNahradVsetkoOdKurzora: TBitBtn;
    btnNahradit: TBitBtn;
    btnNahraditVsetko: TBitBtn;
    btnHladatDalej: TBitBtn;
    btnVlozitPHP: TBitBtn;
    cbPotvrditNahradenie: TCheckBox;
    cbxHTMLAtributy: TCheckListBox;
    cbHTMLVelkePismena: TCheckBox;
    cbHladatRozlisVelkost: TCheckBox;
    cbHladatLenCeleSlova: TCheckBox;
    cmbAktualnyZvyraznovac: TComboBox;
    cmbHTMLVerzie: TComboBox;
    cmbCSSVerzie: TComboBox;
    cmbCSSNovy: TComboBox;
    cmbCSSPseudo: TComboBox;
    cmbCSSHodnoty: TComboBox;
    cmbScriptyVerzie: TComboBox;
    cmbPHPVerzie: TComboBox;
    clxFarba: TColorBox;
    clbFarba: TColorButton;
    cmbDisky: TComboBox;
    ilsObrazky: TImageList;
    imgFarby: TImage;
    Kod: TSynMemo;
    lblPseudo: TLabel;
    lblSelektorTriedaID: TLabel;
    lblCSSVlastnosti: TLabel;
    lblHTMLTagy: TLabel;
    lblHTMLAtributy: TLabel;
    lbxHTMLTagy: TListBox;
    lbxCSSVlastnosti: TListBox;
    lbxSubory: TListBox;
    lsvZnaky: TListView;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    mnNastavenia: TMenuItem;
    mnOpera: TMenuItem;
    mnMozillaFirefox: TMenuItem;
    mnNetscape: TMenuItem;
    mnInternetExplorer: TMenuItem;
    mnSystemovyPrehliadac: TMenuItem;
    mnNahlad: TMenuItem;
    mnPravyPanel: TMenuItem;
    mnVlozitMetaInfo: TMenuItem;
    mnVlozitTabulku: TMenuItem;
    mnStrednyDokument: TMenuItem;
    mnVlozitFormular: TMenuItem;
    mnVlozitObrazok: TMenuItem;
    mnVlozitPoznamku: TMenuItem;
    mnVlozitOdkaz: TMenuItem;
    mnPoslednyDokument: TMenuItem;
    mnNasledujuciSubor: TMenuItem;
    mnPredchadzajuciSubor: TMenuItem;
    mnPrvyDokument: TMenuItem;
    mnVyberFarby: TMenuItem;
    mnMapaZnakov: TMenuItem;
    mnNastroje: TMenuItem;
    mnZmazat: TMenuItem;
    mnVlozitPHP: TMenuItem;
    mnOPrograme: TMenuItem;
    mnTemyPomocnika: TMenuItem;
    mnPomocnik: TMenuItem;
    mnOdsadit: TMenuItem;
    mnZrusitOdsadenie: TMenuItem;
    mnVlozitObjektUdalostScriptov: TMenuItem;
    mnZastavitTlac: TMenuItem;
    mnNastaveniaTlace: TMenuItem;
    mnVelkePismena: TMenuItem;
    mnMalePismena: TMenuItem;
    mnUpravitOznacenyText: TMenuItem;
    MenuItem9: TMenuItem;
    mnZnovuNacitat: TMenuItem;
    mnHladatDalej: TMenuItem;
    mnVlozitCSS: TMenuItem;
    mnVlozitHTML: TMenuItem;
    mnNedavnySubor1: TMenuItem;
    mnNedavnySubor2: TMenuItem;
    mnNedavnySubor3: TMenuItem;
    mnNedavnySubor4: TMenuItem;
    mnNedavnySubor5: TMenuItem;
    mnNedavnySubor6: TMenuItem;
    mnNedavnySubor7: TMenuItem;
    mnNedavnySubor8: TMenuItem;
    mnNedavnySubor9: TMenuItem;
    mnNedavnySubor10: TMenuItem;
    mnHlavneMenu: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    mnOtvoritNedavny: TMenuItem;
    mnHlavnyPanelSNastrojmi: TMenuItem;
    mnZobrazit: TMenuItem;
    mnVlozitTextZoSuboru: TMenuItem;
    mnVlozit: TMenuItem;
    mnOznacZatvorkyPriKurzore: TMenuItem;
    mnIstNaRiadok: TMenuItem;
    dlgNacitatPaletu: TOpenPictureDialog;
    pnlHlavny: TPanel;
    Panely: TTabControl;
    pnlFarby: TPanel;
    pgcNastroje: TPageControl;
    pmSpat: TMenuItem;
    pmDopredu: TMenuItem;
    pmOznacitVsetko: TMenuItem;
    pmVystrihnut: TMenuItem;
    pmKopirovat: TMenuItem;
    pmPrilepit: TMenuItem;
    pmZatvoritVsetky: TMenuItem;
    pmUlozit: TMenuItem;
    pmNovy: TMenuItem;
    mnZatvoritVsetky: TMenuItem;
    MenuItem6: TMenuItem;
    mnTlacit: TMenuItem;
    mnOznacitVsetko: TMenuItem;
    pmZatvorit: TMenuItem;
    mnUlozitVsetky: TMenuItem;
    mnNahradit: TMenuItem;
    mnHladat: TMenuItem;
    mnPrilepit: TMenuItem;
    mnKopirovat: TMenuItem;
    mnVystrihnut: TMenuItem;
    mnDopredu: TMenuItem;
    mnUpravy: TMenuItem;
    mnSpat: TMenuItem;
    mnSubor: TMenuItem;
    mnNovy: TMenuItem;
    mnNovyPredl: TMenuItem;
    mnOtvorit: TMenuItem;
    mnUlozit: TMenuItem;
    mnUlozitAko: TMenuItem;
    mnZatvorit: TMenuItem;
    mnKoniec: TMenuItem;
    dlgOtvorit: TOpenDialog;
    pmPanelov: TPopupMenu;
    pmTextu: TPopupMenu;
    dlgUlozit: TSaveDialog;
    prcRestart: TProcess;
    dlgTlacit: TPrintDialog;
    dlgNastavitTlac: TPrinterSetupDialog;
    rbHladatNadol: TRadioButton;
    rbHladatNahor: TRadioButton;
    StavovyRiadok: TStatusBar;
    snmHladanyText: TSynMemo;
    snmNovyText: TSynMemo;
    snmDocasnyText: TSynMemo;
    shlCSS: TSynCssSyn;
    shlJavaScript: TSynJavaSyn;
    tbsFarby: TTabSheet;
    tbsZnaky: TTabSheet;
    tbsScripty: TTabSheet;
    tbsPHP: TTabSheet;
    tbsCSS: TTabSheet;
    tbsHTML: TTabSheet;
    tbsSubory: TTabSheet;
    tbsHladat: TTabSheet;
    shlHTML: TSynHTMLSyn;
    shlPHP: TSynPHPSyn;
    tbrHlavnaLista: TToolBar;
    tbtNovySubor: TToolButton;
    tbtOtvoritSubor: TToolButton;
    tbtUlozitSubor: TToolButton;
    tbtUlozitAko: TToolButton;
    tbtZatvoritSubor: TToolButton;
    ToolButton1: TToolButton;
    tbtSpat: TToolButton;
    tbtDopredu: TToolButton;
    tbtVystrihnut: TToolButton;
    tbtKopirovat: TToolButton;
    tbtPrilepit: TToolButton;
    tbtHladat: TToolButton;
    ToolButton2: TToolButton;
    tbtNastavenia: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    trvPHP: TTreeView;
    trvScripty: TTreeView;
    procedure AplikaciaException(Sender: TObject; E: Exception);
    procedure AplikaciaUserInput(Sender: TObject; Msg: Cardinal);
    procedure btnNacitatPaletuClick(Sender: TObject);
    procedure btnObnovitSuboryClick(Sender: TObject);
    procedure btnVlozitEntituClick(Sender: TObject);
    procedure btnVlozitFarbuClick(Sender: TObject);
    procedure btnVlozitZnakClick(Sender: TObject);
    procedure clxFarbaChange(Sender: TObject);
    procedure cmbDiskyChange(Sender: TObject);
    procedure FChangeBounds(Sender: TObject);
    procedure btnCSSIdentifikatorClick(Sender: TObject);
    procedure btnCSSSelektorClick(Sender: TObject);
    procedure btnCSSTriedaClick(Sender: TObject);
    procedure btnHladatDalejClick(Sender: TObject);
    procedure btnNahradVsetkoOdKurzoraClick(Sender: TObject);
    procedure btnNahraditClick(Sender: TObject);
    procedure btnNahraditVsetkoClick(Sender: TObject);
    procedure btnPoslednyPanelClick(Sender: TObject);
    procedure btnPrvyPanelClick(Sender: TObject);
    procedure btnVlozitCSSClick(Sender: TObject);
    procedure btnVlozitPHPClick(Sender: TObject);
    procedure btnVlozitTagAtrClick(Sender: TObject);
    procedure btnVlozitZoScriptovClick(Sender: TObject);
    procedure cbxHTMLAtributyMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cmbAktualnyZvyraznovacChange(Sender: TObject);
    procedure cmbCSSVerzieChange(Sender: TObject);
    procedure cmbHTMLVerzieChange(Sender: TObject);
    procedure FClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FCreate(Sender: TObject);
    procedure FHide(Sender: TObject);
    procedure FShow(Sender: TObject);
    procedure imgFarbaMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure KodChange(Sender: TObject);
    procedure KodKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KodKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KodMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure KodMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure KodMouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cmbPHPVerzieChange(Sender: TObject);
    procedure cmbScriptyVerzieChange(Sender: TObject);
    procedure lbxCSSVlastnostiClick(Sender: TObject);
    procedure lbxCSSVlastnostiDblClick(Sender: TObject);
    procedure lbxHTMLTagyClick(Sender: TObject);
    procedure lbxHTMLTagyDblClick(Sender: TObject);
    procedure lbxSuboryDblClick(Sender: TObject);
    procedure lsvZnakyDblClick(Sender: TObject);
    procedure mnDopreduClick(Sender: TObject);
    procedure mnHladatClick(Sender: TObject);
    procedure mnHladatDalejClick(Sender: TObject);
    procedure mnHlavnyPanelSNastrojmiClick(Sender: TObject);
    procedure mnInternetExplorerClick(Sender: TObject);
    procedure mnIstNaRiadokClick(Sender: TObject);
    procedure mnKoniecClick(Sender: TObject);
    procedure mnKopirovatClick(Sender: TObject);
    procedure mnMalePismenaClick(Sender: TObject);
    procedure mnMapaZnakovClick(Sender: TObject);
    procedure mnMozillaFirefoxClick(Sender: TObject);
    procedure mnNahraditClick(Sender: TObject);
    procedure mnNasledujuciSuborClick(Sender: TObject);
    procedure mnNastaveniaClick(Sender: TObject);
    procedure mnNastaveniaTlaceClick(Sender: TObject);
    procedure mnNedavnySubor10Click(Sender: TObject);
    procedure mnNedavnySubor1Click(Sender: TObject);
    procedure mnNedavnySubor2Click(Sender: TObject);
    procedure mnNedavnySubor3Click(Sender: TObject);
    procedure mnNedavnySubor4Click(Sender: TObject);
    procedure mnNedavnySubor5Click(Sender: TObject);
    procedure mnNedavnySubor6Click(Sender: TObject);
    procedure mnNedavnySubor7Click(Sender: TObject);
    procedure mnNedavnySubor8Click(Sender: TObject);
    procedure mnNedavnySubor9Click(Sender: TObject);
    procedure mnNetscapeClick(Sender: TObject);
    procedure mnNovyClick(Sender: TObject);
    procedure mnNovyPredlClick(Sender: TObject);
    procedure mnOdsaditClick(Sender: TObject);
    procedure mnOperaClick(Sender: TObject);
    procedure mnOProgrameClick(Sender: TObject);
    procedure mnOtvoritClick(Sender: TObject);
    procedure mnOznacZatvorkyPriKurzoreClick(Sender: TObject);
    procedure mnOznacitVsetkoClick(Sender: TObject);
    procedure mnPoslednyDokumentClick(Sender: TObject);
    procedure mnPravyPanelClick(Sender: TObject);
    procedure mnPredchadzajuciSuborClick(Sender: TObject);
    procedure mnPrilepitClick(Sender: TObject);
    procedure mnPrvyDokumentClick(Sender: TObject);
    procedure mnSpatClick(Sender: TObject);
    procedure mnStrednyDokumentClick(Sender: TObject);
    procedure mnSystemovyPrehliadacClick(Sender: TObject);
    procedure mnTemyPomocnikaClick(Sender: TObject);
    procedure mnTlacitClick(Sender: TObject);
    procedure mnUlozitAkoClick(Sender: TObject);
    procedure mnUlozitClick(Sender: TObject);
    procedure mnUlozitVsetkyClick(Sender: TObject);
    procedure mnVelkePismenaClick(Sender: TObject);
    procedure mnVlozitCSSClick(Sender: TObject);
    procedure mnVlozitFormularClick(Sender: TObject);
    procedure mnVlozitHTMLClick(Sender: TObject);
    procedure mnVlozitMetaInfoClick(Sender: TObject);
    procedure mnVlozitObjektUdalostScriptovClick(Sender: TObject);
    procedure mnVlozitObrazokClick(Sender: TObject);
    procedure mnVlozitOdkazClick(Sender: TObject);
    procedure mnVlozitPHPClick(Sender: TObject);
    procedure mnVlozitPoznamkuClick(Sender: TObject);
    procedure mnVlozitTabulkuClick(Sender: TObject);
    procedure mnVlozitTextZoSuboruClick(Sender: TObject);
    procedure mnVyberFarbyClick(Sender: TObject);
    procedure mnVystrihnutClick(Sender: TObject);
    procedure mnZastavitTlacClick(Sender: TObject);
    procedure mnZatvoritClick(Sender: TObject);
    procedure mnZatvoritVsetkyClick(Sender: TObject);
    procedure mnZmazatClick(Sender: TObject);
    procedure PanelyChange(Sender: TObject);
    procedure mnZnovuNacitatClick(Sender: TObject);
    procedure mnZrusitOdsadenieClick(Sender: TObject);
    procedure pmDopreduClick(Sender: TObject);
    procedure pmKopirovatClick(Sender: TObject);
    procedure pmNovyClick(Sender: TObject);
    procedure pmOznacitVsetkoClick(Sender: TObject);
    procedure pmPrilepitClick(Sender: TObject);
    procedure pmSpatClick(Sender: TObject);
    procedure pmUlozitClick(Sender: TObject);
    procedure pmUlozitVsetkyClick(Sender: TObject);
    procedure pmVystrihnutClick(Sender: TObject);
    procedure pmZatvoritClick(Sender: TObject);
    procedure pmZatvoritVsetkyClick(Sender: TObject);
    procedure rbHladatNadolMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rbHladatNahorMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure scbPanelovEnter(Sender: TObject);
    procedure tbtDopreduClick(Sender: TObject);
    procedure tbtHladatClick(Sender: TObject);
    procedure tbtKopirovatClick(Sender: TObject);
    procedure tbtNastaveniaClick(Sender: TObject);
    procedure tbtNovySuborClick(Sender: TObject);
    procedure tbtOtvoritSuborClick(Sender: TObject);
    procedure tbtPrilepitClick(Sender: TObject);
    procedure tbtSpatClick(Sender: TObject);
    procedure tbtUlozitAkoClick(Sender: TObject);
    procedure tbtUlozitSuborClick(Sender: TObject);
    procedure tbtVystrihnutClick(Sender: TObject);
    procedure tbtZatvoritSuborClick(Sender: TObject);
    procedure trvPHPDblClick(Sender: TObject);
    procedure trvScriptyDblClick(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

  {-------------------------------------------------------------------------}
  {----------------------- KONSTANTY A PREMENNE ----------------------------}

  {-- vseobecne konstanty --}
const
  MAX_DOK = 1024; // maximalny pocet naraz otvorenych dokumentov
  MAX_UNDO = 1024; // maximalny pocet prvkov pola 'undo' pre kazdy dokument osobitne
  KONC_ZVYRAZ_SUBORU = '.ewh'; // koncouvka suboru s nastavenim zvyraznovaca
  KONC_JAZYK_SUBORU = '.ewl'; // NUTNE ZMENIT AJ V NASTAV.PAS !!!!!
  KONC_PREDLOHY = '.ewt'; // koncovka suboru - predlohy
  KONC_WEB_NASTROJA = '.eww'; // koncovka suboru webovych nastrojov
  KONC_INI_SUBORU = '.ini';  // koncovka suboru s nastaveniami
  MR_NIC = 100;
  MR_OKEY = 101;
  MR_ZRUSIT = 102;
  MR_ZASTAVIT = 103;
  MR_ZNOVA = 104;
  MR_IGNOROVAT = 105;
  MR_ANO = 106;
  MR_NIE = 107;
  MR_VSETKO = 108;
  MR_NIE_PRE_VSETKO = 109;
  MR_ANO_PRE_VSETKO = 110;

  {-- vseobecne premenne --}
var
  F: TF; // formular
  PrvyKratUkazane: boolean = true;
  p_panelov: integer; // aktualny pocet panelov - 1
  nazvy: array[0..MAX_DOK] of string; // pole nazvov suborov aj z cestou
  texty: array[0..MAX_DOK] of string; // samotne texty
  zmenene: array[0..MAX_DOK] of boolean; // urcuje, ci bol dokument zmeneny od posledneho ulozenia
  ulozene: array[0..MAX_DOK] of boolean; // urcuje, ci bol dany dokument uz ulozeny
  undo: array[0..MAX_DOK] of array[0..MAX_UNDO] of string; // texty pamate 'spat'
  undo_pocet: array[0..MAX_DOK] of integer; // index pamate 'spat'
  PozicieKurzora: array[0..MAX_DOK] of array[0..MAX_UNDO] of TPoint; // ulozene suradnice synmema
  ZvyraznovaceDok: array[0..MAX_DOK] of word; // cisla zvyraznovacov jednotlivych dokumentov
  NasSub, NedavneSubory,JazSub: TIniFile; // subory s hlavnymi nastav., nazvami nedav. suborov a jazykom
  HTMLIniSubor, CSSIniSubor: TIniFile; // subory nastaveni web. nastrojov
  AktualnyAdresar: string; // adresar zobrazovany na paneli

  {-------------------------------------------------------------------------}
  {--------------------------- IMPLEMENTACIA -------------------------------}
  
implementation

  {$INCLUDE jazyky.inc}

  {$INCLUDE vseobecne.inc}

  {$INCLUDE nastavenia.inc}

  {$INCLUDE subor.inc}

  {$INCLUDE upravy.inc}

  {$INCLUDE web.inc}

  {-- restartuje program editwebs --}
procedure Restart;
begin
  fmNastav.Hide;
  if UlozVsetkyZmeny = 'pokracuj' then begin
    F.prcRestart.Execute; // spusti sa proces - novy editwebs
    Application.Terminate; // tato aplikacia sa zavrie
  end;
end;

  {-- zisti ci subory s nastaveniami nie su readonly --}
procedure ReadOnlyNastavSub;
begin
  if (
  (FileExists('settings\settings'+KONC_INI_SUBORU))
  and (not FileIsWritable('settings\settings'+KONC_INI_SUBORU))
  )
  or (
  (FileExists('settings\recent'+KONC_INI_SUBORU))
  and (not FileIsWritable('settings\recent'+KONC_INI_SUBORU))
  ) then
    QuestionDlg(txVarovanie,txNastavSubReadOnly1+GetCurrentDir+txNastavSubReadOnly2,
    mtWarning,[MR_OKEY,txTlOK],0);
end;

  {-------------------------------------------------------------------------}
  {------------------------- UDALOSTI FORMULARA ----------------------------}
  
{ TF }

  {-- na zaciatku, pri vytvoreni formulara --}
procedure TF.FCreate(Sender: TObject);
var
  c: integer;
begin
  F.pnlHlavny.FullRepaint := false;
  F.pgcNastroje.DoubleBuffered := true; // zabrani blikaniu?
  ChDir(ExtractFilePath(Application.ExeName)); // zmeni aktualnu zlozku na spravnu, ak ma program parametre
  ReadOnlyNastavSub;
  F.Panely.Tabs.Delete(1); // kvoli chybe - ak je na zaciatku len 1 panel, nefunguje..
                           // ..spravne nastavenie aktivneho panelu. toto zmaze..
                           // ..prebytocny panel a nastavenie pritom bude fungovat
  p_panelov := 0; // pocet panelov je 1
  // zvyraznovace su html
  for c:=0 to MAX_DOK do begin
    ZvyraznovaceDok[c] := 1;
  end;
  if not DirectoryExists('settings') then
    CreateDir('settings');
  NasSub := TIniFile.Create('settings\settings'+KONC_INI_SUBORU); // otvorenie suboru s hlavnymi nastaveniami
  NedavneSubory := TIniFile.Create('settings\recent'+KONC_INI_SUBORU); // otvorenie suboru s nazvami nedavnych suborov
  NacitatNedavneSubory;
  NacitatDisky;
  NacitatZnaky;
  NacitatPaletu;
  Pozicie;
end;

  {-- pri zobrazeni formulara --}
procedure TF.FShow(Sender: TObject);
begin
  if not DirectoryExists('lang') then
    CreateDir('lang');
  JazSub := TIniFile.Create('lang\'+NasSub.ReadString('Hlavne','JazykProgramu','english'+KONC_JAZYK_SUBORU));
  if ExtractFileName(JazSub.FileName) <> 'slovencina'+KONC_JAZYK_SUBORU then begin
    NacitatJazyk; // zapis textov prislusneho jazyka, slovencina je pocas navrhu, anglictina je predvolena v ini-subore
  end;
  F.snmHladanyText.Lines.Text := txHladanyText;
  F.snmNovyText.Lines.Text := txNovyText;
  if (F.Enabled) and (PrvyKratUkazane) then begin // ak je hlavny formular povoleny, teda by nad nim nemalo byt ziadne okno
    VykonatNastaveniaPriSpusteni; // vykona nastavenia, ktore sa vykonavaju len pri spusteni
    VykonatNastavenia; // vykona ostatne nastavenia
    UlozitNastavenia;
    F.Kod.SetFocus; // aktivny prvok bude synmemo
    PrvyKratUkazane := false;
  end;
  if FileExists(Application.Params[1]) then
    OtvoritSubor(Application.Params[1]);
end;

  {-- pri zmene pozicie okna --}
procedure TF.FChangeBounds(Sender: TObject);
begin
  //if fmNastav.IsVisible then // ak je otvorene okno nastaveni,..
  //  fmNastav.SetFocus; // .. tak sa ukaze
end;

  {-- pri skryti formulara --}
procedure TF.FHide(Sender: TObject);
begin
  F.WindowState := wsMinimized;
end;

  {-- pri zatvarani formulara --}
procedure TF.FCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  fmNastav.Hide;
  if UlozVsetkyZmeny = 'stop' then
    CanClose := false; // zabrani zatvoreniu aplikacie
end;

  {-- pri zatvoreni formulara --}
procedure TF.FClose(Sender: TObject; var CloseAction: TCloseAction);
var
  VysledkyHladania: TSearchRec;
begin
  UlozitNastavenia;
  if FindFirst('temp\*.html',faAnyFile,VysledkyHladania) = 0 then // ak bol najdeny aspon 1 subor
    repeat
      DeleteFile(Pchar('temp\'+VysledkyHladania.Name));
    until FindNext(VysledkyHladania) <> 0; // kym sa este nejaky jazyk. subor nachadza
end;


  {-------------------------------------------------------------------------}
  {--------------------------- ROZNE UDALOSTI ------------------------------}

  {-- pri vynimke --}
procedure TF.AplikaciaException(Sender: TObject; E: Exception);
var
  popisChyby: string;
begin
  popisChyby := E.ClassName+'('+E.Message+')'; // ak nebude dalej uvedena, napise sa povodna, anglicka
  if E.ClassName = 'EAccessViolation' then
    popisChyby := txChChybaPristupu;
  if E.ClassName = 'EExternal' then
    popisChyby := txChExternaChyba;
  if E.ClassName = 'EFCreateError' then
    popisChyby := txChNemoznoVytvoritSubor;
  if E.ClassName = 'EFOpenError' then
    popisChyby := txChNemoznoOtvoritSubor;
  if E.ClassName = 'EHeapMemoryError' then
    popisChyby := txChChybaPamate;
  if E.ClassName = 'EInOutError' then
    popisChyby := txChVstupnoVystupnaChyba;
  if E.ClassName = 'EInvalidGraphic' then
    popisChyby := txChGrafickaChyba;
  if E.ClassName = 'EInvalidOperation' then
    popisChyby := txChNespravnaOperacia;
  if E.ClassName = 'EOSError' then
    popisChyby := txChChybaOS;
  if E.ClassName = 'EPrinter' then
    popisChyby := txChChybaTlace;
  if E.ClassName = 'ERangeError' then
    popisChyby := txChPretecenie;
  if E.ClassName = 'EWin32Error' then
    popisChyby := txChChybaWin32;
  if E.ClassName = 'Exception' then
    popisChyby := txChZavaznaChyba;
  QuestionDlg(txChyba,popisChyby+#13+E.Message,mtError,[MR_OKEY,txTlOK],0);
end;

  {-- pri prenose dat z ineho okna --}
procedure TF.AplikaciaUserInput(Sender: TObject; Msg: Cardinal);
begin
  if (Msg = 0) or (Msg = 2) then begin // ak sa druhe okno zatvara
    F.Enabled := true; // hlavny formular bude povoleny, nie je nad nim ziadne okno
    F.ShowOnTop;
    F.Kod.SetFocus;
  end;
  if (Sender = fmNastav) and (Msg = 0) then // ak sa neodosielaju informacie o nastaveniach
    VykonatNastavenia; // vykonaju sa povodne, nove sa neulozia
  if (Sender = fmNastav) and ((Msg = 1) or (Msg = 2)) then begin // ak sa odosielaju informacie
    UlozitNastavenia; // nastavenia sa ulozia
    VykonatNastavenia; // hned sa aj vykonaju
    if (fmNastav.lbxJazyky.ItemIndex > -1)
    and (NasSub.ReadString('Hlavne','JazykProgramu','english'+KONC_JAZYK_SUBORU) <> fmNastav.lbxJazyky.Items[fmNastav.lbxJazyky.ItemIndex])
    and (QuestionDlg(txRestart,txRestartTeraz,mtConfirmation,[MR_ANO,txTlAno,MR_NIE,txTlNie],0) = MR_ANO) then
      Restart;
  end;
end;

  {-- pri zmene zvyraznovaca --}
procedure TF.cmbAktualnyZvyraznovacChange(Sender: TObject);
var
  Zvyraznovac: string;
begin
  Zvyraznovac := F.cmbAktualnyZvyraznovac.Items[F.cmbAktualnyZvyraznovac.ItemIndex];
  if Zvyraznovac = 'HTML' then
    F.Kod.Highlighter := F.shlHTML;
  if Zvyraznovac = 'CSS' then
    F.Kod.Highlighter := F.shlCSS;
  if Zvyraznovac = 'JavaScript' then
    F.Kod.Highlighter := F.shlJavaScript;
  if Zvyraznovac = 'PHP' then
    F.Kod.Highlighter := F.shlPHP;
  if F.cmbAktualnyZvyraznovac.ItemIndex = 0 then
    F.Kod.Highlighter := nil;
  ZvyraznovaceDok[F.Panely.TabIndex] := F.cmbAktualnyZvyraznovac.ItemIndex;
end;

  {-- pri zmene panelov --}
procedure TF.PanelyChange(Sender: TObject);
begin
  F.Kod.Lines.Text := texty[F.Panely.TabIndex]; // nacitanie textu z prvku pola do synmema
  F.Kod.setFocus; // nastavenie aktivneho prvku na synmemo
  F.Kod.CaretXY := PozicieKurzora[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]];
  F.cmbAktualnyZvyraznovac.ItemIndex := ZvyraznovaceDok[F.Panely.TabIndex];
  F.cmbAktualnyZvyraznovacChange(Sender);
end;

  {-- pri zmene synmema --}
procedure TF.KodChange(Sender: TObject);
begin
  if (F.Kod.Lines.Text <> texty[F.Panely.TabIndex]) or (Sender = F.mnOtvorit) then begin
    undo[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]] := F.Kod.Lines.Text;
    undo_pocet[F.Panely.TabIndex] := undo_pocet[F.Panely.TabIndex]+1; // zmena indexu 'spat'
    texty[F.Panely.TabIndex] := F.Kod.Lines.Text; // ulozenie obsahu synmema do prvku pola
    zmenene[F.Panely.TabIndex] := true; // dokument bol zmeneny
    if LeftStr(F.Panely.Tabs[F.Panely.TabIndex],1) <> '*' then
      F.Panely.Tabs[F.Panely.TabIndex] := '*'+F.Panely.Tabs[F.Panely.TabIndex]; // pridanie hviezdicky
  end;
  Pozicie;
end;

  {-- pri stlaceni klavesu, ak je aktivne synmemo --}
procedure TF.KodKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  // pri stlaceni sipky dolava na zaciatku riadka sa kurzor presunie na koniec predch. riadka:
  if (Key = 37) and (F.Kod.CaretX = 1) and (F.Kod.CaretY > 1) then begin
    F.Kod.CaretY := F.Kod.CaretY-1;
    F.Kod.CaretX := Length(F.Kod.LineText)+2;
  end;
  Pozicie;
end;

  {-- pri pusteni klavesu, ak je aktivne synmemo --}
procedure TF.KodKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  F.KodChange(Sender); // ak sa prepisuje oznaceny text, onchange reaguje na zmenu prilis skoro
  Pozicie;
end;

  {-- pri stlaceni tlacidla mysi nad synmemom --}
procedure TF.KodMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Pozicie;
end;

  {-- pri pohybe mysi nad synmemom --}
procedure TF.KodMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  Pozicie;
end;

  {-- pri pusteni klavesu, ak je aktivne synmemo --}
procedure TF.KodMouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Pozicie;
end;

  {-- pri vstupe na scrollbar panelov --}
procedure TF.scbPanelovEnter(Sender: TObject);
begin
  F.Kod.SetFocus;
end;


  {-------------------------------------------------------------------------}
  {--------------------------- MENU A INE ----------------------------------}

  {-- hlavne menu --}
procedure TF.mnDopreduClick(Sender: TObject);
begin
  Dopredu;
end;

procedure TF.mnHladatClick(Sender: TObject);
begin
  MenuHladat;
end;

procedure TF.mnHladatDalejClick(Sender: TObject);
begin
  Hladat(snmHladanyText.Lines,true,F.rbHladatNadol.Checked);
end;

procedure TF.mnHlavnyPanelSNastrojmiClick(Sender: TObject);
begin
  HlavnyPanel;
end;

procedure TF.mnInternetExplorerClick(Sender: TObject);
begin
  Nahlad(fmNastav.fneInternetExplorer.Text);
end;

procedure TF.mnIstNaRiadokClick(Sender: TObject);
begin
  IstNaRiadok;
end;

procedure TF.mnKoniecClick(Sender: TObject);
begin
  Koniec;
end;

procedure TF.mnKopirovatClick(Sender: TObject);
begin
  Kopirovat;
end;

procedure TF.mnMalePismenaClick(Sender: TObject);
begin
  MalePismena;
end;

procedure TF.mnMapaZnakovClick(Sender: TObject);
begin
  MenuNastroj(F.tbsZnaky,F.btnVlozitZnak,F.btnVlozitEntitu);
end;

procedure TF.mnMozillaFirefoxClick(Sender: TObject);
begin
  Nahlad(fmNastav.fneMozillaFirefox.Text);
end;

procedure TF.mnNahraditClick(Sender: TObject);
begin
  MenuNahradit;
end;

procedure TF.mnNasledujuciSuborClick(Sender: TObject);
begin
  NasledujuciSubor;
end;

procedure TF.mnNastaveniaClick(Sender: TObject);
begin
  OtvoritOknoNastavenia;
end;

procedure TF.mnNastaveniaTlaceClick(Sender: TObject);
begin
  NastavitTlac;
end;

procedure TF.mnNedavnySubor1Click(Sender: TObject);
begin
  OtvoritNedavnySubor(1);
end;

procedure TF.mnNedavnySubor2Click(Sender: TObject);
begin
  OtvoritNedavnySubor(2);
end;

procedure TF.mnNedavnySubor3Click(Sender: TObject);
begin
  OtvoritNedavnySubor(3);
end;

procedure TF.mnNedavnySubor4Click(Sender: TObject);
begin
  OtvoritNedavnySubor(4);
end;

procedure TF.mnNedavnySubor5Click(Sender: TObject);
begin
  OtvoritNedavnySubor(5);
end;

procedure TF.mnNedavnySubor6Click(Sender: TObject);
begin
  OtvoritNedavnySubor(6);
end;

procedure TF.mnNedavnySubor7Click(Sender: TObject);
begin
  OtvoritNedavnySubor(7);
end;

procedure TF.mnNedavnySubor8Click(Sender: TObject);
begin
  OtvoritNedavnySubor(8);
end;

procedure TF.mnNedavnySubor9Click(Sender: TObject);
begin
  OtvoritNedavnySubor(9);
end;

procedure TF.mnNedavnySubor10Click(Sender: TObject);
begin
  OtvoritNedavnySubor(10);
end;

procedure TF.mnNetscapeClick(Sender: TObject);
begin
  Nahlad(fmNastav.fneNetscape.Text);
end;

procedure TF.mnNovyClick(Sender: TObject);
begin
  Novy;
end;

procedure TF.mnNovyPredlClick(Sender: TObject);
begin
  DialogNovyZPredlohy;
end;

procedure TF.mnOdsaditClick(Sender: TObject);
begin
  Odsadit;
end;

procedure TF.mnOperaClick(Sender: TObject);
begin
  Nahlad(fmNastav.fneOpera.Text);
end;

procedure TF.mnOProgrameClick(Sender: TObject);
begin
  OPrograme;
end;

procedure TF.mnOtvoritClick(Sender: TObject);
begin
  Otvorit;
end;

procedure TF.mnOznacZatvorkyPriKurzoreClick(Sender: TObject);
begin
  OznacZatvorkyPriKurzore;
end;

procedure TF.mnOznacitVsetkoClick(Sender: TObject);
begin
  OznacitVsetko;
end;

procedure TF.mnPoslednyDokumentClick(Sender: TObject);
begin
  IstNaPoslednyPanel;
end;

procedure TF.mnPravyPanelClick(Sender: TObject);
begin
  PravyPanel;
end;

procedure TF.mnPredchadzajuciSuborClick(Sender: TObject);
begin
  PredchadzajuciSubor;
end;

procedure TF.mnPrilepitClick(Sender: TObject);
begin
  Prilepit;
end;

procedure TF.mnPrvyDokumentClick(Sender: TObject);
begin
  IstNaPrvyPanel;
end;

procedure TF.mnSpatClick(Sender: TObject);
begin
  Spat(true);
end;

procedure TF.mnStrednyDokumentClick(Sender: TObject);
begin
  IstNaStrednyPanel;
end;

procedure TF.mnSystemovyPrehliadacClick(Sender: TObject);
begin
  Nahlad('explorer');
end;

procedure TF.mnTemyPomocnikaClick(Sender: TObject);
begin
  TemyPomocnika;
end;

procedure TF.mnTlacitClick(Sender: TObject);
begin
  Tlacit;
end;

procedure TF.mnUlozitClick(Sender: TObject);
begin
  Ulozit;
end;

procedure TF.mnUlozitAkoClick(Sender: TObject);
begin
  UlozitAko;
end;

procedure TF.mnUlozitVsetkyClick(Sender: TObject);
begin
  UlozitVsetky;
end;

procedure TF.mnVelkePismenaClick(Sender: TObject);
begin
  VelkePismena;
end;

procedure TF.mnVlozitCSSClick(Sender: TObject);
begin
  MenuNastroj(F.tbsCSS,F.cmbCSSVerzie,F.cmbCSSNovy);
end;

procedure TF.mnVlozitFormularClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsFormular);
end;

procedure TF.mnVlozitHTMLClick(Sender: TObject);
begin
  MenuNastroj(F.tbsHTML,F.cmbHTMLVerzie,F.lbxHTMLTagy);
end;

procedure TF.mnVlozitMetaInfoClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsMetaInfo);
end;

procedure TF.mnVlozitObjektUdalostScriptovClick(Sender: TObject);
begin
  MenuNastroj(F.tbsScripty,F.cmbScriptyVerzie,F.btnVlozitZoScriptov);
end;

procedure TF.mnVlozitObrazokClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsObrazok);
end;

procedure TF.mnVlozitOdkazClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsOdkaz);
end;

procedure TF.mnVlozitPHPClick(Sender: TObject);
begin
  MenuNastroj(F.tbsPHP,F.cmbPHPVerzie,F.btnVlozitPHP);
end;

procedure TF.mnVlozitPoznamkuClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsPoznamka);
end;

procedure TF.mnVlozitTabulkuClick(Sender: TObject);
begin
  DialogVlozit(fmVkladat.tbsTabulka);
end;

procedure TF.mnVlozitTextZoSuboruClick(Sender: TObject);
begin
  VlozitTextZoSuboru;
end;

procedure TF.mnVyberFarbyClick(Sender: TObject);
begin
  MenuNastroj(F.tbsFarby,F.btnNacitatPaletu,F.btnVlozitFarbu);
end;

procedure TF.mnVystrihnutClick(Sender: TObject);
begin
  Vystrihnut;
end;

procedure TF.mnZastavitTlacClick(Sender: TObject);
begin
  ZastavitTlac;
end;

procedure TF.mnZatvoritClick(Sender: TObject);
begin
  Zatvorit;
end;

procedure TF.mnZatvoritVsetkyClick(Sender: TObject);
begin
  ZatvoritVsetky;
end;

procedure TF.mnZmazatClick(Sender: TObject);
begin
  Zmazat;
end;

procedure TF.mnZnovuNacitatClick(Sender: TObject);
begin
  ZnovuNacitat;
end;

procedure TF.mnZrusitOdsadenieClick(Sender: TObject);
begin
  ZrusitOdsadenie;
end;

  {-- popup menu --}
procedure TF.pmDopreduClick(Sender: TObject);
begin
  Dopredu;
end;

procedure TF.pmKopirovatClick(Sender: TObject);
begin
  Kopirovat;
end;

procedure TF.pmNovyClick(Sender: TObject);
begin
  Novy;
end;

procedure TF.pmOznacitVsetkoClick(Sender: TObject);
begin
  OznacitVsetko;
end;

procedure TF.pmPrilepitClick(Sender: TObject);
begin
  Prilepit;
end;

procedure TF.pmSpatClick(Sender: TObject);
begin
  Spat(true);
end;

procedure TF.pmUlozitClick(Sender: TObject);
begin
  Ulozit;
end;

procedure TF.pmUlozitVsetkyClick(Sender: TObject);
begin
  UlozitVsetky;
end;

procedure TF.pmVystrihnutClick(Sender: TObject);
begin
  Vystrihnut;
end;

procedure TF.pmZatvoritClick(Sender: TObject);
begin
  Zatvorit;
end;

procedure TF.pmZatvoritVsetkyClick(Sender: TObject);
begin
  ZatvoritVsetky;
end;

  {-- panel s tlacidlami --}
procedure TF.tbtDopreduClick(Sender: TObject);
begin
  Dopredu;
end;

procedure TF.tbtHladatClick(Sender: TObject);
begin
  MenuHladat;
end;

procedure TF.tbtKopirovatClick(Sender: TObject);
begin
  Kopirovat;
end;

procedure TF.tbtNastaveniaClick(Sender: TObject);
begin
  OtvoritOknoNastavenia;
end;
  
procedure TF.tbtNovySuborClick(Sender: TObject);
begin
  Novy;
end;

procedure TF.tbtOtvoritSuborClick(Sender: TObject);
begin
  Otvorit;
end;

procedure TF.tbtPrilepitClick(Sender: TObject);
begin
  Prilepit;
end;

procedure TF.tbtSpatClick(Sender: TObject);
begin
  Spat(true);
end;

procedure TF.tbtUlozitAkoClick(Sender: TObject);
begin
  UlozitAko;
end;

procedure TF.tbtUlozitSuborClick(Sender: TObject);
begin
  Ulozit;
end;

procedure TF.tbtVystrihnutClick(Sender: TObject);
begin
  Vystrihnut;
end;

procedure TF.tbtZatvoritSuborClick(Sender: TObject);
begin
  Zatvorit;
end;

  {-- tlacidla --}
procedure TF.btnCSSSelektorClick(Sender: TObject);
begin
  ZapisCSS('');
end;

procedure TF.btnCSSTriedaClick(Sender: TObject);
begin
  ZapisCSS('.');
end;

procedure TF.btnCSSIdentifikatorClick(Sender: TObject);
begin
  ZapisCSS('#');
end;

procedure TF.btnHladatDalejClick(Sender: TObject);
begin
  Hladat(snmHladanyText.Lines,true,F.rbHladatNadol.Checked);
end;

procedure TF.btnNacitatPaletuClick(Sender: TObject);
begin
  NacitatPaletuZoSuboru;
end;

procedure TF.btnObnovitSuboryClick(Sender: TObject);
begin
  VypisAdresar(AktualnyAdresar);
end;

procedure TF.btnNahraditClick(Sender: TObject);
begin
  Nahradit;
end;

procedure TF.btnNahraditVsetkoClick(Sender: TObject);
begin
  NahraditVsetkoOdZaciatku;
end;

procedure TF.btnPoslednyPanelClick(Sender: TObject);
begin
  IstNaPoslednyPanel;
end;

procedure TF.btnPrvyPanelClick(Sender: TObject);
begin
  IstNaPrvyPanel;
end;

procedure TF.btnNahradVsetkoOdKurzoraClick(Sender: TObject);
begin
  NahraditVsetkoOdKurzora;
end;

procedure TF.btnVlozitCSSClick(Sender: TObject);
begin
  VlozitCSS;
end;

procedure TF.btnVlozitEntituClick(Sender: TObject);
begin
  VlozitEntitu;
end;

procedure TF.btnVlozitFarbuClick(Sender: TObject);
begin
  VlozitFarbu;
end;

procedure TF.btnVlozitPHPClick(Sender: TObject);
begin
  VlozitPHP;
end;

procedure TF.btnVlozitTagAtrClick(Sender: TObject);
begin
  VlozitHTMLTagAtr;
end;

procedure TF.btnVlozitZoScriptovClick(Sender: TObject);
begin
  VlozitZoStromuScriptov;
end;

procedure TF.btnVlozitZnakClick(Sender: TObject);
begin
  VlozitZnak;
end;

  {-- ine --}
procedure TF.cbxHTMLAtributyMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ZapisVyberHTMLAtributu;
end;

procedure TF.clxFarbaChange(Sender: TObject);
begin
  VybratFarbuZoZoznamu;
end;

procedure TF.cmbDiskyChange(Sender: TObject);
begin
  ZmenitDisk;
end;

procedure TF.cmbCSSVerzieChange(Sender: TObject);
begin
  ZmenaCSSVerzie;
end;

procedure TF.cmbHTMLVerzieChange(Sender: TObject);
begin
  ZmenaHTMLVerzie;
end;
  
procedure TF.cmbPHPVerzieChange(Sender: TObject);
begin
  ZmenaPHPVerzie;
end;

procedure TF.cmbScriptyVerzieChange(Sender: TObject);
begin
  ZmenaVerzieScriptov;
end;

procedure TF.imgFarbaMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  VybratFarbuZPalety(X,Y);
end;

procedure TF.lbxCSSVlastnostiClick(Sender: TObject);
begin
  CSSVlastnostiHodnoty;
end;

procedure TF.lbxCSSVlastnostiDblClick(Sender: TObject);
begin
  VlozitCSS;
end;
  
procedure TF.lbxHTMLTagyClick(Sender: TObject);
begin
  HTMLTagyAtributy;
end;

procedure TF.lbxHTMLTagyDblClick(Sender: TObject);
begin
  VlozitHTMLTagAtr;
end;

procedure TF.lbxSuboryDblClick(Sender: TObject);
begin
  OtvoritAdrSubor;
end;

procedure TF.lsvZnakyDblClick(Sender: TObject);
begin
  VlozitEntitu;
end;

procedure TF.rbHladatNadolMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  F.Kod.CaretXY := PoziciaNaXY(Length(TextPredKurzorom)+Length(F.Kod.SelText)+1);
end;

procedure TF.rbHladatNahorMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  F.Kod.CaretXY := PoziciaNaXY(Length(TextPredKurzorom)-Length(F.Kod.SelText)+1);
end;

procedure TF.trvPHPDblClick(Sender: TObject);
begin
  VlozitPHP;
end;

procedure TF.trvScriptyDblClick(Sender: TObject);
begin
  VlozitZoStromuScriptov;
end;

initialization
  {$I hlavne.lrs}

end.


  {-------------------------------------------------------------------------}
  {----------------------------- POZNAMKY ----------------------------------}

// CHYBA: po minimalizacii, ak je otvorene druhe okno

// CHYBA: zvolenie adresara nazvaneho *.ewl ako jazyk

// MOZNE VYLEPSENIE: ukladanie oznaceneho textu, aby sa nacitaval pri zmene panelov,
// mozno aj pri spat/dopredu

