  {-------------------------------------------------------------------------}
  {------------------------------- SUBOR -----------------------------------}

{*
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}

  {-- novy subor --}
procedure Novy;
var
  c: integer;
begin
  if p_panelov < MAX_DOK then begin
    F.Panely.Tabs.Add(txNovySubor); // pridanie noveho panela
    p_panelov := p_panelov+1; // zvacsenie premennej s poctom panelov
    F.Panely.TabIndex := p_panelov; // nastavenie aktivneho panela na posledny
    F.Kod.Lines.Clear; // vymazanie synmema
    F.Kod.CaretXY := Point(1,1);
    for c := 0 to MAX_UNDO do
      undo[F.Panely.TabIndex][c] := '';
  end
  else
    QuestionDlg(txInformacia,txOtvMaxPocetDok,mtInformation,[MR_OKEY,txTlOK],0);
end;

  {-- otvori dialog templates --}
procedure DialogNovyZPredlohy;
begin
  Novy;
  F.Enabled := false; // nove okno ostane aktivne, hlavny formular nie je povoleny
  fmPredlohy.Show; // ukazanie okna (vytvorene uz bolo)
end;

  {-- otvorit subor zadany v parametri --}
procedure OtvoritSubor(nazov_suboru: string);
begin
  if p_panelov < MAX_DOK then begin // ak nie je otvoreny max. pocet dokumentov
    Novy; // vytvory novy dokument
    nazvy[F.Panely.TabIndex] := nazov_suboru; // do prvku pola sa nacita cely nazov
    F.Panely.Tabs[F.Panely.TabIndex] := ExtractFileName(nazov_suboru); // nazov panela sa zmeni na nazov suboru bez cesty
    NacitajZoSuboru(F.Kod,nazov_suboru);
    ulozene[F.Panely.TabIndex] := true; // kedze subor bol uz na disku, je ulozeny
    F.KodChange(F.mnOtvorit); // osetrenie chyby
    zmenene[F.Panely.TabIndex] := false; // za kodChange
    if LeftStr(F.Panely.Tabs[F.Panely.TabIndex],1) = '*' then // odobratie hviezdicky, ktora znamena zmenu
      F.Panely.Tabs[F.Panely.TabIndex] := RightStr(F.Panely.Tabs[F.Panely.TabIndex],Length(F.Panely.Tabs[F.Panely.TabIndex])-1);
    ObnovitNedavneSubory;
    ZmenZvyrazNovehoDok;
  end
  else
    QuestionDlg(txInformacia,txOtvMaxPocetDok,mtInformation,[MR_OKEY,txTlOK],0);
end;

  {-- otvorit subory zadane v parametri --}
procedure OtvoritSubory(nazvy_suborov: TStrings);
var
  c: integer;
begin
  for c := 0 to nazvy_suborov.Count-1 do // postupne otvaranie suborov
    OtvoritSubor(nazvy_suborov[c]);
end;

  {-- otvorit subor po zobrazeni dialogu --}
procedure Otvorit;
begin
  Application.ProcessMessages;
  if F.dlgOtvorit.execute then// dialog na otvorenie suboru
    OtvoritSubory(F.dlgOtvorit.Files); // moznost - viac suborov alebo jeden
end;

  {-- otvori nedavny subor --}
procedure OtvoritNedavnySubor(cislo: integer);
var
  DocasnyText: TStringList;
begin
  DocasnyText := TStringList.Create;
  NedavneSubory.ReadSections(DocasnyText);
  OtvoritSubor(DocasnyText[cislo-1]);
end;

  {-- znovu nacita obsah dokumentu zo suboru --}
procedure ZnovuNacitat;
begin
  if (nazvy[F.panely.TabIndex] <> '') and (FileExists(nazvy[F.panely.TabIndex])) then
    NacitajZoSuboru(F.Kod,nazvy[F.panely.TabIndex]);
end;

  {-- ulozit subor pod inym nazvom --}
procedure UlozitAko;
begin
  Application.ProcessMessages;
  if F.dlgUlozit.execute then begin // dialog na ulozenie suboru
    UlozDoSuboru(F.Kod,F.dlgUlozit.FileName); // ulozenie obsahu synmema do suboru
    nazvy[F.Panely.TabIndex] := F.dlgUlozit.FileName; // priradenie celeho nazvu suboru do prvku pola nazvy
    F.Panely.Tabs[F.Panely.TabIndex] := ExtractFileName(F.dlgUlozit.FileName); // nazov panela sa zmeni na nazov suboru bez cesty
    zmenene[F.Panely.TabIndex] := false; // uz nie je zmeneny bez ulozenia
    ulozene[F.Panely.TabIndex] := true; // prvok pola ulozene sa zmeni na true
    ObnovitNedavneSubory;
    ZmenZvyrazNovehoDok;
  end;
end;

  {-- ulozi subor --}
procedure Ulozit;
begin
  if ulozene[F.Panely.TabIndex] = false then begin
    UlozitAko; // ak subor este nebol ulozeny, vyvola sa procedura
  end
  else begin
    UlozDoSuboru(F.Kod,nazvy[F.Panely.TabIndex]); // ulozenie obsahu synmema do suboru
    zmenene[F.Panely.TabIndex] := false; // uz nie je zmeneny bez ulozenia
    ulozene[F.Panely.TabIndex] := true; // prvok pola ulozene sa zmeni na true
    if LeftStr(F.Panely.Tabs[F.Panely.TabIndex],1) = '*' then
      F.Panely.Tabs[F.Panely.TabIndex] := RightStr(F.Panely.Tabs[F.Panely.TabIndex],Length(F.Panely.Tabs[F.Panely.TabIndex])-1);
  end;
  ObnovitNedavneSubory;
end;

  {-- ulozenie vsetkych otvorenych dokumentov --}
procedure UlozitVsetky;
var
  aktivny_panel, c: integer;
begin
  aktivny_panel := F.Panely.TabIndex; // zisti prave aktivny panel
  for c:=0 to p_panelov do begin // cyklus menenia aktivneho panela a ukladania
    F.Panely.TabIndex := c;
    Ulozit;
  end;
  F.Panely.TabIndex := aktivny_panel; // nastavi aktivny panel na hodnotu ako predtym
end;

  {-- opytanie sa na ulozenie zmien --}
function UlozitZmeny: string;
var
  odpoved: TModalResult;
begin
  if zmenene[F.Panely.TabIndex] then begin
    odpoved := QuestionDlg(txPotvrdenie,txPrUlozitSubor,mtCustom,
    [MR_ANO,txTlAno,MR_NIE,txTlNie,MR_ZRUSIT,txTlZrusit],0);
    if odpoved = MR_ANO then begin // ano
       Ulozit;
       Result := 'pokracuj';
    end;
    if odpoved = MR_NIE then // nie
      Result := 'pokracuj';
    if odpoved = MR_ZRUSIT then // zrusit
      Result := 'stop';
  end
  else
  Result := 'pokracuj'; // ak nebol zmeneny, vrati 'pokracuj'
end;

  {-- ulozit vseky zmeny --}
function UlozVsetkyZmeny: string;
var
  c: integer;
  odpoved: TModalResult;
begin
  for c:=0 to p_panelov do begin // postupne zistuje od zaciatku po koniec
    F.Panely.TabIndex := c;
    if zmenene[c] then begin
      odpoved := QuestionDlg(txPotvrdenie,txPrUlozitSubory,mtConfirmation,
      [MR_ANO,txTlAno,MR_NIE,txTlNie,MR_ZRUSIT,txTlZrusit,
      MR_NIE_PRE_VSETKO,txTlNiePreVsetko],0);
      case odpoved of
        MR_ANO: begin // ano
          Ulozit; Result := 'pokracuj';
        end;
        MR_NIE: // nie
          Result := 'pokracuj';
        MR_ZRUSIT,2: begin // zrusit
          Result := 'stop'; Break;
        end;
        MR_NIE_PRE_VSETKO: begin // nie pre vsetko
          Result := 'pokracuj'; Break;
        end;
      end;
    end
    else
      Result := 'pokracuj'; // ak nic nebolo zmenene
  end;
end;

  {-- zatvorenie samotne, bez opytania --}
procedure Zatvorenie;
var
  c, d: integer;
  je_posledny: boolean = false;
  aktivny_panel: integer;
begin
  aktivny_panel := F.Panely.TabIndex; // zisti cislo aktivneho panelu
  if F.Panely.TabIndex = p_panelov then // osetri chybu ak je..
    je_posledny := true;               // .. panel posledny
  nazvy[F.Panely.TabIndex] := '';      // mazanie..
  texty[F.Panely.TabIndex] := '';
  zmenene[F.Panely.TabIndex] := false;
  ulozene[F.Panely.TabIndex] := false;
  for c:=0 to MAX_UNDO do
    undo[F.Panely.TabIndex][c] := '';
  undo_pocet[F.Panely.TabIndex] := 0; // ..hodnot prvkov pola
  F.Panely.Tabs.Delete(F.Panely.TabIndex); // zmaze panel
  if je_posledny = false then begin
    for c:=F.Panely.TabIndex to MAX_DOK-1 do begin// preradovanie..
      nazvy[c] := nazvy[c+1];
      texty[c] := texty[c+1];
      zmenene[c] := zmenene[c+1];
      ulozene[c] := ulozene[c+1];
      undo_pocet[c] := undo_pocet[c+1];
      for d:=0 to MAX_UNDO do
        undo[F.Panely.TabIndex][d] := undo[F.Panely.TabIndex][d+1];
    end;                                            // ..kvoli zmene tabindexu
  end;
  if p_panelov > 0 then
    p_panelov := p_panelov-1 // zmensi premennu pocet panelov
  else begin                       // aby nemohlo byt..
    Novy; p_panelov := p_panelov-1;// ..otvorenych 0 dokumentov
  end;
  F.Panely.TabIndex := 1; F.Panely.TabIndex := 0; // osetrenie 'chyby'
  F.Panely.TabIndex := aktivny_panel; // nastavit aktivny panel
end;


  {-- zatvorenie dokumentu --}
procedure Zatvorit;
begin
  if UlozitZmeny = 'pokracuj' then  // opytat sa na ulozenie
    Zatvorenie;
end;

  {-- zatvorenie vsetkych dokumentov --}
procedure ZatvoritVsetky;
var
  c, d: integer;
  odpoved: TModalResult;
begin
  for c:=0 to p_panelov do begin // postupne zistuje od zaciatku po koniec
    F.Panely.TabIndex := 0;
    if zmenene[0] then begin
      odpoved := QuestionDlg(txPotvrdenie,txPrUlozitSubory,mtConfirmation,
      [MR_ANO,txTlAno,MR_NIE,txTlNie,MR_ZRUSIT,txTlZrusit,
      MR_NIE_PRE_VSETKO,txTlNiePreVsetko],0);
      case odpoved of
        MR_ANO: begin // ano
          Ulozit; Zatvorenie;
        end;
        MR_NIE: begin // nie
          Zatvorenie;
        end;
        MR_ZRUSIT,2: // zrusit
          Break;
        MR_NIE_PRE_VSETKO: begin // nie pre vsetko
          for d := 0 to p_panelov do begin
            F.Panely.TabIndex := d; Zatvorenie;
          end;
          Break;
        end;
      end;
    end
    else
      Zatvorenie;
  end;
end;

  {-- dialog s nastaveniami tlace --}
procedure NastavitTlac;
begin
  F.dlgNastavitTlac.Execute;
end;

  {-- vytlacenie dokumentu --}
procedure Tlacit;
begin
  if F.dlgTlacit.Execute then begin
    Printer.BeginDoc;
    Printer.Canvas.TextOut(0,0,F.Kod.Lines.Text);
    Printer.EndDoc;
  end;
end;

  {-- zastavi aktualne tlaceny dokument --}
procedure ZastavitTlac;
begin
  if Printer.Printing then
    Printer.Abort;
end;

  {-- ukoncenie programu --}
procedure Koniec;
begin
  if UlozVsetkyZmeny = 'pokracuj' then
    Application.Terminate; // ukoncenie aplikacie
end;

