  {-------------------------------------------------------------------------}
  {------------------------------ UPRAVY -----------------------------------}

{*
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}

  {-- spat --}
procedure Spat(zmena: boolean);
begin
  if ((nazvy[F.Panely.TabIndex] = '') and (undo_pocet[F.Panely.TabIndex] > 0)) // ak sa da ist spat
  or ((nazvy[F.Panely.TabIndex] <> '') and (undo_pocet[F.Panely.TabIndex] > 1)) then begin
    undo_pocet[F.Panely.TabIndex] := undo_pocet[F.Panely.TabIndex]-1; // zmena indexu
    F.Kod.Lines.Text := undo[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]-1];
    texty[F.Panely.TabIndex] := F.Kod.Lines.Text; // ulozenie do pola textov
    F.Kod.CaretXY := PozicieKurzora[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]];
    if zmena then begin // ak sa text zmenil
      if LeftStr(F.Panely.Tabs[F.Panely.TabIndex],1) <> '*' then
        F.Panely.Tabs[F.Panely.TabIndex] := '*'+F.Panely.Tabs[F.Panely.TabIndex];
      zmenene[F.Panely.TabIndex] := true;
    end;
    Pozicie;
  end;
end;

  {-- dopredu --}
procedure Dopredu;
begin
  F.Kod.Lines.Text := undo[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]];
  undo_pocet[F.Panely.TabIndex] := undo_pocet[F.Panely.TabIndex]+1; // zmena indexu
  if (undo_pocet[F.Panely.TabIndex] <> 0) and (F.Kod.Lines.Text = '') then
    Spat(false);
  texty[F.Panely.TabIndex] := F.Kod.Lines.Text; // ulozenie do pola textov
  F.Kod.CaretXY := PozicieKurzora[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]];
  Pozicie;
end;

  {-- vystrihnut --}
procedure Vystrihnut;
begin
  F.Kod.CutToClipboard;
end;

  {-- kopirovat --}
procedure Kopirovat;
begin
  F.Kod.CopyToClipboard;
end;

  {-- prilepit --}
procedure Prilepit;
begin
  F.Kod.PasteFromClipboard;
end;

  {-- oznac zatvorky pri ukazovateli --}
procedure OznacZatvorkyPriKurzore;
begin
  F.Kod.SelectToBrace;
end;

  {-- oznacit vsetko --}
procedure OznacitVsetko;
begin
  F.Kod.SelectAll;
end;

  {-- upravi oznaceny text na male pismena --}
procedure MalePismena;
begin
  Pis(WideLowerCase(F.Kod.SelText));
end;

 {-- upravi oznaceny text na velke pismena --}
procedure VelkePismena;
begin
  Pis(WideUpperCase(F.Kod.SelText));
end;

  {-- odsadi oznaceny text --}
procedure Odsadit;
begin
  F.Kod.ExecuteCommand(610,'',nil);
end;

  {-- zrusi odsadenie oznaceneho textu --}
procedure ZrusitOdsadenie;
begin
  F.Kod.ExecuteCommand(611,'',nil);
end;

  {-- zmaze oznaceny text --}
procedure Zmazat;
begin
  F.Kod.SelText := '';
end;

  {-- ukonci oznacenie na aktualnej pozicii --}
procedure UkoncitOznacenie;
begin
  if F.Kod.CaretX < F.Kod.MaxLeftChar then begin
    F.Kod.ExecuteCommand(102,'',nil); // oznacenie doprava
    F.Kod.ExecuteCommand(101,'',nil); // oznacenie dolava
  end
  else begin
    F.Kod.ExecuteCommand(101,'',nil); // oznacenie dolava
    F.Kod.ExecuteCommand(102,'',nil); // oznacenie doprava
  end;
end;

  {-- odznacit --}
procedure Odznacit;
begin
  if F.Kod.CaretX < F.Kod.MaxLeftChar then begin
    F.Kod.ExecuteCommand(2,'',nil); // ist doprava
    F.Kod.ExecuteCommand(1,'',nil); // ist dolava
  end
  else begin
    F.Kod.ExecuteCommand(1,'',nil); // ist dolava
    F.Kod.ExecuteCommand(2,'',nil); // ist doprava
  end;
end;

  {-- zistit suradnice x,y z ciselnej pozicie --}
function PoziciaNaXY(pozicia: integer): TPoint;
var
  docasna_pozicia, x, y: integer;
begin
  docasna_pozicia := 0;
  for y := 1 to F.Kod.Lines.Count do begin
    if docasna_pozicia+Length(F.Kod.Lines[y-1])+1 < pozicia then
      docasna_pozicia := docasna_pozicia+Length(F.Kod.Lines[y-1])+1
    else
      break;
  end;
  x := pozicia-docasna_pozicia;
  Result := Point(x,y);
end;

  {-- odstrani zle znaky --}
function TStringsBezZlychZnakov(t_strings: TStrings): string;
var
  novy_text: string;
  c: integer;
begin
  novy_text := '';
  for c := 0 to t_strings.Count-1 do
    novy_text := novy_text+t_strings[c]+#13;
  if t_strings[t_strings.Count-1] <> '' then  begin
    Result := LeftStr(novy_text,Length(novy_text)-1) ; end
  else
     Result := novy_text; // zle znaky = viacznakove konce riadkov, atd.
end;

  {-- zisti text pred kurzorom --}
function TextPredKurzorom: string;
var
  text_pred: string;
  y: integer;
begin
  text_pred := '';
  for y := 1 to F.Kod.CaretY-1 do
    text_pred := text_pred+F.Kod.Lines[y-1]+#13;
  text_pred := text_pred+LeftStr(F.Kod.LineText,F.Kod.CaretX-1);
  if not F.cbHladatRozlisVelkost.Checked then
    text_pred := WideLowerCase(text_pred);
  Result := text_pred;
end;

  {-- zisti text za kurzorom --}
function TextZaKurzorom: string;
var
  text_za: string;
  y: integer;
begin
  text_za := '';
  for y := F.Kod.CaretY+1 to F.Kod.Lines.Count do
    text_za := text_za+F.Kod.Lines[y-1]+#13;
  text_za := RightStr(F.Kod.LineText,Length(F.Kod.LineText)-F.Kod.CaretX+1)+#13+text_za;
  if not F.cbHladatRozlisVelkost.Checked then
    text_za := WideLowerCase(text_za);
  Result := text_za;
end;

  {-- najde posledny vyskyt jedneho retazca v druhom --}
function PoslednyVyskyt(hladany_text,cely_text: string) :integer;
var
  docasny_text: string;
  vyskyt: integer;
begin
  docasny_text := cely_text;
  vyskyt := 0;
  while Pos(hladany_text,docasny_text) > 0 do begin
    vyskyt := vyskyt+Pos(hladany_text,docasny_text);
    docasny_text := RightStr(docasny_text,Length(docasny_text)-Pos(hladany_text,docasny_text));
  end;
  Result := vyskyt;
end;

  {-- hladat text smerom hore --}
procedure HladatNahor(t_strings: TStrings; hlasky: boolean; posledna_uspesna_poz: TPoint);
var
  hladany_text, pred_kurzorom, lave_pismeno, prave_pismeno: string;
  poz: integer;
begin
  hladany_text := TStringsBezZlychZnakov(t_strings);
  if F.cbHladatRozlisVelkost.Checked = false then begin
    hladany_text := WideLowerCase(hladany_text);
  end;
  if ((t_strings.Count > 1) or (t_strings[0] <> ''))  then begin // ak hladany text nie je prazdny
    pred_kurzorom := TextPredKurzorom;
    poz := PoslednyVyskyt(hladany_text,pred_kurzorom);
    if Pos(hladany_text,pred_kurzorom) > 0 then begin // ak je najdeny
      F.Kod.CaretXY := PoziciaNaXY(poz+Length(hladany_text));
      F.Kod.ExecuteCommand(102,'',nil); // oznacenie doprava-ak bude maxleftchar tak mozno nepojde
      F.Kod.CaretXY := PoziciaNaXY(poz); // pozicia konca oznacenia
      UkoncitOznacenie;
      lave_pismeno := RightStr(LeftStr(F.Kod.LineText,F.Kod.CaretX-1),1);
      prave_pismeno := LeftStr(RightStr(F.Kod.LineText,Length(F.Kod.LineText)-F.Kod.CaretX-Length(hladany_text)+1),1);
      if (F.cbHladatLenCeleSlova.Checked) // hladat len cele slova
      and ( (WideLowerCase(lave_pismeno) <> WideUpperCase(lave_pismeno))
       or (WideLowerCase(prave_pismeno) <> WideUpperCase(prave_pismeno)) ) then begin
        Odznacit;
        HladatNahor(t_strings,true,posledna_uspesna_poz); // ak nebude cele slovo
      end;
    end
    else begin// ak nie je najdeny
      if hlasky then
        QuestionDlg(txInformacia,txTextNenajdeny,mtInformation,[MR_OKEY,txTlOK],0);
      F.Kod.CaretXY := posledna_uspesna_poz;
    end;
  end
  else
    if hlasky then
      QuestionDlg(txInformacia,txTextNenajdeny,mtInformation,[MR_OKEY,txTlOK],0);
end;

  {-- hladat text smerom dole --}
procedure HladatNadol(t_strings: TStrings; hlasky: boolean; posledna_uspesna_poz: TPoint);
var
  hladany_text, za_kurzorom, lave_pismeno, prave_pismeno: string;
  poz: integer;
begin
  hladany_text := TStringsBezZlychZnakov(t_strings);
  if F.cbHladatRozlisVelkost.Checked = false then begin
    hladany_text := WideLowerCase(hladany_text);
  end;
  if ((t_strings.Count > 1) or (t_strings[0] <> ''))  then begin // ak hladany text nie je prazdny
    za_kurzorom := TextZaKurzorom;
    poz := Length(TextPredKurzorom)+Pos(hladany_text,za_kurzorom); //!
    if Pos(hladany_text,za_kurzorom) > 0 then begin //! ak je najdeny
      F.Kod.CaretXY := PoziciaNaXY(poz);
      F.Kod.ExecuteCommand(102,'',nil); // oznacenie doprava-ak bude maxleftchar tak mozno nepojde
      F.Kod.CaretXY := PoziciaNaXY(poz+Length(hladany_text)); // pozicia konca oznacenia
      UkoncitOznacenie;
      lave_pismeno := RightStr(LeftStr(F.Kod.LineText,F.Kod.CaretX-Length(hladany_text)-1),1);
      prave_pismeno := LeftStr(RightStr(F.Kod.LineText,Length(F.Kod.LineText)-F.Kod.CaretX+1),1);
      if (F.cbHladatLenCeleSlova.Checked) // hladat len cele slova
      and ( (WideLowerCase(lave_pismeno) <> WideUpperCase(lave_pismeno))
       or (WideLowerCase(prave_pismeno) <> WideUpperCase(prave_pismeno)) ) then begin
        Odznacit;
        HladatNadol(t_strings,true,posledna_uspesna_poz); // ak nebude cele slovo
      end;
    end
    else begin // ak nie je najdeny
      if hlasky then
        QuestionDlg(txInformacia,txTextNenajdeny,mtInformation,[MR_OKEY,txTlOK],0);
      F.Kod.CaretXY := posledna_uspesna_poz;
    end;
  end
  else
    if hlasky then
      QuestionDlg(txInformacia,txTextNenajdeny,mtInformation,[MR_OKEY,txTlOK],0);
end;

  {-- po kliknuti na menu hladat --}
procedure MenuHladat;
begin
  F.pgcNastroje.ActivePage := F.tbsHladat;
  F.snmHladanyText.Lines.Text := txHladanyText;
  F.snmHladanyText.setFocus;
  F.snmHladanyText.SelectAll;
end;

  {-- hladat text --}
procedure Hladat(t_strings :TStrings; hlasky :boolean; nadol: boolean);
begin
  F.Kod.Cursor := crHourGlass;
  Application.ProcessMessages;
  Odznacit;
  if nadol then
    HladatNadol(t_strings,hlasky,F.Kod.CaretXY)
  else
    HladatNahor(t_strings,hlasky,F.Kod.CaretXY);
  F.Kod.setFocus;
  Pozicie;
  if hlasky then // ak nebude hladanie (nahradzanie) pokracovat
    F.Kod.Cursor := crDefault;
end;

  {-- po kliknuti na menu nahradit --}
procedure MenuNahradit;
begin
  F.pgcNastroje.ActivePage := F.tbsHladat;
  F.snmHladanyText.Lines.Text := txHladanyText;
  F.snmHladanyText.setFocus;
  F.snmHladanyText.SelectAll;
  F.snmNovyText.Lines.Text := txNovyText;
end;

  {-- nahradit text --}
procedure Nahradit;
var
  pozicia_konca: TPoint;
begin
  Hladat(F.snmHladanyText.Lines,true,F.rbHladatNadol.Checked);
  if F.Kod.SelText <> '' then begin // ak bol text najdeny
    if (F.cbPotvrditNahradenie.Checked = false)
    or (QuestionDlg(txPotvrdenie,txNaozajNahrad,mtCustom,
    [MR_ANO,txTlAno,MR_NIE,txTlNie],0) = MR_ANO) then begin
      Pis(TStringsBezZlychZnakov(F.snmNovyText.Lines));
      pozicia_konca := F.Kod.CaretXY;
      F.Kod.CaretXY := PoziciaNaXY(Length(TextPredKurzorom)-Length(TStringsBezZlychZnakov(F.snmNovyText.Lines))+1);
      F.Kod.ExecuteCommand(102,'',nil); // oznacenie doprava-ak bude maxleftchar tak mozno nepojde
      F.Kod.CaretXY := pozicia_konca;
      UkoncitOznacenie;
    end;
  end;
end;

 {-- nahradi vsetko od zaciatku textu --}
procedure NahraditVsetkoOdZaciatku;
begin
  F.Kod.CaretXY := Point(1,1);
  Hladat(F.snmHladanyText.Lines,true,true);
  if F.Kod.SelText <> '' then begin
    if ((F.cbPotvrditNahradenie.Checked = false)
    or (QuestionDlg(txPotvrdenie,txNaozajNahradVsetko,mtCustom,
    [MR_ANO,txTlAno,MR_NIE,txTlNie],0) = MR_ANO)) then begin
      while F.Kod.SelText <> '' do begin
        F.Kod.SelText := TStringsBezZlychZnakov(F.snmNovyText.Lines);
        Hladat(F.snmHladanyText.Lines,false,true);
      end;
    end;
  end;
  F.Kod.Cursor := crDefault;
end;

 {-- nahradi v texte od pozicie kurzora --}
procedure NahraditVsetkoOdKurzora;
begin
  Hladat(F.snmHladanyText.Lines,true,F.rbHladatNadol.Checked);
  if F.Kod.SelText <> '' then begin
    if ((F.cbPotvrditNahradenie.Checked = false)
    or (QuestionDlg(txPotvrdenie,txNaozajNahradVsetko,mtCustom,
    [MR_ANO,txTlAno,MR_NIE,txTlNie],0) = MR_ANO)) then begin
      while F.Kod.SelText <> '' do begin
        F.Kod.SelText := TStringsBezZlychZnakov(F.snmNovyText.Lines);
        Hladat(F.snmHladanyText.Lines,false,F.rbHladatNadol.Checked);
      end;
    end;
  end;
  F.Kod.Cursor := crDefault;
end;

  {-- ist na riadok.. --}
procedure IstNaRiadok;
var
  riadok, vysl: integer;
begin
  Val(InputBox(txIstNaRiadok,txCisloRiadku,IntToStr(F.Kod.CaretY)),riadok,vysl);
  if vysl <> 0 then // osetrenie chyby
    QuestionDlg(txVarovanie,txNespravneCislo,mtWarning,[MR_OKEY,txTlOK],0)
  else
  F.Kod.CaretY := riadok;
  F.Kod.setFocus;
end;

