  {-------------------------------------------------------------------------}
  {------------------------ FORMULAR 'VLOZIT' ------------------------------}

{*
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}

unit vkladat;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ComCtrls,
  Buttons, StdCtrls, ExtCtrls, Spin, ExtDlgs, Grids;

type

  { TfmVkladat }

  TfmVkladat = class(TForm)
    btnNacitatObrazok: TBitBtn;
    btnZrusit: TBitBtn;
    btnVlozit: TBitBtn;
    cbUrcitTabIndexOdkazu: TCheckBox;
    cbRamcekObrazka: TCheckBox;
    cbPresmerovanie: TCheckBox;
    cbAdresaPresmerovania: TCheckBox;
    cmbUkladanie: TComboBox;
    cmbZakodovanieForm: TComboBox;
    cmbProtokol: TComboBox;
    cmbZarovnanieObrazka: TComboBox;
    cmbMetodaForm: TComboBox;
    cmbKodovanie: TComboBox;
    edtAdresaPresmerovania: TEdit;
    edtAutor: TEdit;
    edtVyprsanie: TEdit;
    edtPopisStranky: TEdit;
    edtKlucoveSlova: TEdit;
    edtSpracovatelForm: TEdit;
    edtNazovForm: TEdit;
    edtTitulokObrazka: TEdit;
    edtAltTextObrazka: TEdit;
    edtSuborObrazka: TEdit;
    edtTextOdkazu: TEdit;
    edtCielOdkazu: TEdit;
    edtTitulokOdkazu: TEdit;
    imgObrazok: TImage;
    lblAutor: TLabel;
    lblVyprsanie: TLabel;
    lblUkladanie: TLabel;
    lblPopisStranky: TLabel;
    lblKlucoveSlova: TLabel;
    lblKodovanie: TLabel;
    lblRiadky: TLabel;
    lblNazovForm: TLabel;
    lblMetodaForm: TLabel;
    lblStlpce: TLabel;
    lblPocetSekund: TLabel;
    lblZakodovanieForm: TLabel;
    lblSpracovatelForm: TLabel;
    lblZarovnanieObrazka: TLabel;
    lblTitulokObrazka: TLabel;
    lblAltText: TLabel;
    lblSirkaObrazka: TLabel;
    lblVyskaObrazka: TLabel;
    lblSuborObrazka: TLabel;
    lblTextPoznamky: TLabel;
    lblTitulokOdkazu: TLabel;
    lblTabIndexOdkazu: TLabel;
    lblCielOdkazu: TLabel;
    lblTextOdkazu: TLabel;
    memTextPoznamky: TMemo;
    dlgObrazok: TOpenPictureDialog;
    pnlObrazok: TPanel;
    pgcVkladat: TPageControl;
    sedVyskaObrazka: TSpinEdit;
    sedTabIndexOdkazu: TSpinEdit;
    sedSirkaObrazka: TSpinEdit;
    sedRamcekObrazka: TSpinEdit;
    sgdTabulka: TStringGrid;
    sedRiadky: TSpinEdit;
    sedStlpce: TSpinEdit;
    sedPocetSekund: TSpinEdit;
    tbsMetaInfo: TTabSheet;
    tbsTabulka: TTabSheet;
    tbsFormular: TTabSheet;
    tbsObrazok: TTabSheet;
    tbsPoznamka: TTabSheet;
    tbsOdkaz: TTabSheet;
    procedure btnNacitatObrazokClick(Sender: TObject);
    procedure btnVlozitClick(Sender: TObject);
    procedure btnZrusitClick(Sender: TObject);
    procedure cbAdresaPresmerovaniaChange(Sender: TObject);
    procedure cbPresmerovanieChange(Sender: TObject);
    procedure cbUrcitRamcekObrazkaChange(Sender: TObject);
    procedure cbUrcitTabIndexOdkazuChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure sedRiadkyChange(Sender: TObject);
    procedure sedStlpceChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmVkladat: TfmVkladat;

implementation

uses
  Hlavne;

{ TfmVkladat }

procedure TfmVkladat.btnZrusitClick(Sender: TObject);
begin
  Close;
end;

procedure TfmVkladat.cbAdresaPresmerovaniaChange(Sender: TObject);
begin
  edtAdresaPresmerovania.Enabled := cbAdresaPresmerovania.Checked;
end;

procedure TfmVkladat.cbPresmerovanieChange(Sender: TObject);
begin
  lblPocetSekund.Enabled := cbPresmerovanie.Checked;
  sedPocetSekund.Enabled := cbPresmerovanie.Checked;
  cbAdresaPresmerovania.Enabled := cbPresmerovanie.Checked;
  edtAdresaPresmerovania.Enabled := cbPresmerovanie.Checked and cbAdresaPresmerovania.Checked;
end;

procedure TfmVkladat.cbUrcitRamcekObrazkaChange(Sender: TObject);
begin
  sedRamcekObrazka.Enabled := cbRamcekObrazka.Checked;
end;

procedure TfmVkladat.cbUrcitTabIndexOdkazuChange(Sender: TObject);
begin
  sedTabIndexOdkazu.Enabled := cbUrcitTabIndexOdkazu.Checked;
end;

procedure TfmVkladat.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  F.Enabled := true; // hlavny formular bude povoleny, nie je nad nim ziadne okno
  F.ShowOnTop;
  F.Kod.SetFocus;
end;

procedure TfmVkladat.sedRiadkyChange(Sender: TObject);
begin
  sgdTabulka.RowCount := sedRiadky.Value;
  sgdTabulka.ColCount := sedStlpce.Value;
end;

procedure TfmVkladat.sedStlpceChange(Sender: TObject);
begin
  fmVkladat.sedRiadkyChange(Sender);
end;

procedure TfmVkladat.btnVlozitClick(Sender: TObject);
var
  zdroj: string = '';
  c, d: integer;
begin
  if pgcVkladat.ActivePage = tbsPoznamka then begin
    zdroj += '<!-- '+memTextPoznamky.Lines.Text+' -->';
  end;
  if pgcVkladat.ActivePage = tbsOdkaz then begin
    zdroj += '<a href="'+cmbProtokol.Text+edtCielOdkazu.Text+'"';
    if cbUrcitTabIndexOdkazu.Checked then
      zdroj += ' tabindex="'+IntToStr(sedTabIndexOdkazu.Value)+'"';
    if edtTitulokOdkazu.Text <> '' then
      zdroj += ' title="'+edtTitulokOdkazu.Text+'"';
    zdroj += '>'+edtTextOdkazu.Text+'</a>';
  end;
  if pgcVkladat.ActivePage = tbsObrazok then begin
    zdroj += '<img src="'+edtSuborObrazka.Text+'"';
    zdroj += ' width="'+IntToStr(sedSirkaObrazka.Value)+'"';
    zdroj += ' height="'+IntToStr(sedVyskaObrazka.Value)+'"';
    if cmbZarovnanieObrazka.Text <> '' then
      zdroj += ' align="'+cmbZarovnanieObrazka.Text+'"';
    if cbRamcekObrazka.Checked then
      zdroj += ' border="'+IntToStr(sedRamcekObrazka.Value)+'"';
    zdroj += ' alt="'+edtAltTextObrazka.Text+'"';
    if edtTitulokObrazka.Text <> '' then
      zdroj += ' title="'+edtTitulokObrazka.Text+'"';
    zdroj += '/>';
  end;
  if pgcVkladat.ActivePage = tbsFormular then begin
    zdroj += '<form action="'+edtSpracovatelForm.Text+'"';
    if edtNazovForm.Text <> '' then
      zdroj += ' name="'+edtNazovForm.Text+'"';
    if cmbMetodaForm.Text <> '' then
      zdroj += ' method="'+cmbMetodaForm.Text+'"';
    if cmbZakodovanieForm.Text <> '' then
      zdroj += ' enctype="'+cmbZakodovanieForm.Text+'"';
    zdroj += '>'#13#13'</form>';
  end;
  if pgcVkladat.ActivePage = tbsTabulka then begin
    zdroj += '<table>'#13;
    for c := 1 to sgdTabulka.RowCount do begin
      zdroj += '<tr>'#13;
      for d := 1 to sgdTabulka.ColCount do
        zdroj += '<td>'+sgdTabulka.Cells[d-1, c-1]+'</td>'#13;
      zdroj += '</tr>'#13;
    end;
    zdroj += '</table>';
  end;
  if pgcVkladat.ActivePage = tbsMetaInfo then begin
    if edtPopisStranky.Text <> '' then
      zdroj += '<meta name="description" content="'+edtPopisStranky.Text+'"/>'#13;
    if edtKlucoveSlova.Text <> '' then
      zdroj += '<meta name="keywords" content="'+edtKlucoveSlova.Text+'"/>'#13;
    if edtAutor.Text <> '' then
      zdroj += '<meta name="author" content="'+edtAutor.Text+'"/>'#13;
    if cmbKodovanie.Text <> '' then
      zdroj += '<meta http-equiv="content-type" content="text/html; charset='
      +cmbKodovanie.Text+'"/>'#13;
    if cmbUkladanie.Text <> '' then
      zdroj += '<meta http-equiv="cache-control" content="'
      +cmbUkladanie.Text+'"/>'#13;
    if edtVyprsanie.Text <> '' then
      zdroj += '<meta http-equiv="expires" content="'
      +edtVyprsanie.Text+'"/>'#13;
    if cbPresmerovanie.Checked then begin
      zdroj += '<meta http-equiv="refresh" content="'
      +IntToStr(sedPocetSekund.Value);
      if cbAdresaPresmerovania.Checked then
        zdroj += ';URL='+edtAdresaPresmerovania.Text;
      zdroj += '"/>'#13;
    end;
  end;
  F.Kod.SelText := zdroj;
  Close;
end;

procedure TfmVkladat.btnNacitatObrazokClick(Sender: TObject);
begin
  if dlgObrazok.Execute then begin
    imgObrazok.Picture.LoadFromFile(dlgObrazok.FileName);
    edtSuborObrazka.Text := ExtractFileName(dlgObrazok.FileName);
    sedSirkaObrazka.Value := imgObrazok.Picture.Width;
    sedVyskaObrazka.Value := imgObrazok.Picture.Height;
  end;
end;

initialization
  {$I vkladat.lrs}

end.

