  {-------------------------------------------------------------------------}
  {---------------------------- VSEOBECNE ----------------------------------}

{*
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}

  {-- zapise text do synmema na aktualnu poziciu --}
procedure Pis(pisany_text: string);
begin
  F.Kod.SelText := pisany_text;
  F.Kod.SetFocus;
end;

  {-- nahrada tsynmemo.loadfromfile --}
procedure NacitajZoSuboru(syn_memo: TSynMemo; nazov_suboru: string);
var
  c: integer;
  novy_tabulator: string;
  DocasnyText: TStringList;
begin
  for c := 1 to syn_memo.TabWidth do
    novy_tabulator := novy_tabulator+' ';
  DocasnyText := TStringList.Create;
  DocasnyText.LoadFromFile(nazov_suboru);
  syn_memo.Lines.Text := StringReplace(DocasnyText.Text,'	',novy_tabulator,[rfReplaceAll]); // tab -> medzery
end;

  {-- nahrada tsynmemo.savetofile --}
procedure UlozDoSuboru(syn_memo: TSynMemo; nazov_suboru: string);
var
  Subor: TextFile;
  c: integer;
  novy_tabulator: string;
begin
  novy_tabulator := '';
  for c := 1 to syn_memo.TabWidth do
    novy_tabulator := novy_tabulator+' ';
  AssignFile(Subor,nazov_suboru);
  Rewrite(Subor);
  for c := 0 to syn_memo.Lines.Count-1 do begin
    WriteLn(Subor,StringReplace(syn_memo.Lines[c],novy_tabulator,'	',[rfReplaceAll])); // medzery -> tab
  end;
  CloseFile(Subor);
end;

  {-- zapisovanie pozicii --}
procedure Pozicie;
begin
  F.StavovyRiadok.Panels[0].Text := txRiadok+' '+IntToStr(F.Kod.CaretY);
  F.StavovyRiadok.Panels[1].Text := txStlpec+' '+IntToStr(F.Kod.CaretX);
  PozicieKurzora[F.Panely.TabIndex][undo_pocet[F.Panely.TabIndex]] := F.Kod.CaretXY;
end;

  {-- ist na prvy panel --}
procedure IstNaPrvyPanel;
begin
  F.Panely.TabIndex := 0;
end;

  {-- zobrazi stredny panel --}
procedure IstNaStrednyPanel;
begin
  F.Panely.TabIndex := F.Panely.Tabs.Count div 2;
end;

  {-- zobrazi posledny panel --}
procedure IstNaPoslednyPanel;
begin
  F.Panely.TabIndex := F.Panely.Tabs.Count-1;
end;

  {-- zobrazi predchadzajuci panel --}
procedure PredchadzajuciSubor;
begin
  if F.Panely.TabIndex > 0 then
    F.Panely.TabIndex := F.Panely.TabIndex-1;
end;

  {-- zobrazi nasledujuci panel --}
procedure NasledujuciSubor;
begin
  if F.Panely.TabIndex < F.Panely.Tabs.Count-1 then
    F.Panely.TabIndex := F.Panely.TabIndex+1;
end;

  {-- zmeni zvyraznovac noveho alebo otvoreneho dokumentu --}
procedure ZmenZvyrazNovehoDok;
var
  NazovSuboru, Koncovka, Filter, Zvyraznovac: string;
begin
  NazovSuboru := nazvy[F.Panely.TabIndex];
  Koncovka := ';'+WideLowerCase(RightStr(ExtractFileExt(NazovSuboru),Length(ExtractFileExt(NazovSuboru))-1))+';';
  Zvyraznovac := '---';
  // html:
  Filter := ';'+WideLowerCase(fmNastav.edtFilterHTML.Text)+';';
  if Pos(Koncovka,Filter) > 0 then
    Zvyraznovac := 'HTML';
  // css:
  Filter := ';'+WideLowerCase(fmNastav.edtFilterCSS.Text)+';';
  if Pos(Koncovka,Filter) > 0 then
    Zvyraznovac := 'CSS';
  // javascript:
  Filter := ';'+WideLowerCase(fmNastav.edtFilterJavaScript.Text)+';';
  if Pos(Koncovka,Filter) > 0 then
    Zvyraznovac := 'JavaScript';
  // php:
  Filter := ';'+WideLowerCase(fmNastav.edtFilterPHP.Text)+';';
  if Pos(Koncovka,Filter) > 0 then
    Zvyraznovac := 'PHP';
  // nic:
  if NazovSuboru = '' then
    Zvyraznovac := 'HTML';
  if F.cmbAktualnyZvyraznovac.Items.IndexOf(Zvyraznovac) > -1 then
    F.cmbAktualnyZvyraznovac.ItemIndex := F.cmbAktualnyZvyraznovac.Items.IndexOf(Zvyraznovac);
  if Zvyraznovac = '---' then
    F.cmbAktualnyZvyraznovac.ItemIndex := 0;
  F.cmbAktualnyZvyraznovacChange(F);
end;

  {-- zobrazi/skryje hlavny panel s nastrojmi --}
procedure HlavnyPanel;
begin
  F.tbrHlavnaLista.Visible := F.mnHlavnyPanelSNastrojmi.Checked;
end;

  {-- zobrazi/skryje pravy panel --}
procedure PravyPanel;
begin
  if F.mnPravyPanel.Checked then
    F.pgcNastroje.Left := F.Width-220
  else
    F.pgcNastroje.Left := F.Width-2;
end;

  {-- zobrazi nastroj a urobi prvok aktivnym --}
procedure MenuNastroj(zalozka: TTabSheet; prvok1, prvok2: TWinControl);
begin
  F.mnPravyPanel.Checked := true;
  PravyPanel;
  F.pgcNastroje.ActivePage := zalozka;
  if F.ActiveControl <> prvok1 then
    prvok1.SetFocus
  else
    prvok2.SetFocus;
end;

  {-- vlozi text zo suboru do aktualneho dokumentu --}
procedure VlozitTextZoSuboru;
begin
  Application.ProcessMessages; // osetrenie chyby
  if F.dlgOtvorit.execute then begin
    F.snmDocasnyText.Lines.Clear;
    NacitajZoSuboru(F.snmDocasnyText,F.dlgOtvorit.FileName);
    // docasne nacitanie, zjednodusenie
    Pis(#13+F.snmDocasnyText.Lines.Text); // vlozenie na aktualnu poziciu
  end;
end;

  {-- otvori dialog vlozenia --}
procedure DialogVlozit(zalozka: TTabSheet);
begin
  F.Enabled := false; // nove okno ostane aktivne, hlavny formular nie je povoleny
  fmVkladat.pgcVkladat.ActivePage := zalozka;
  fmVkladat.Show; // ukazanie okna (vytvorene uz bolo)
end;

  {-- nahlad v prehliadaci --}
procedure Nahlad(nazov_prog: string);
var
  nazov: string;
begin
  if not DirectoryExists('temp') then
    CreateDir('temp');
  nazov := 'temp\'+IntToStr(GetTickCount)+'.html';
  F.Kod.Lines.SaveToFile(nazov);
  WinExec(PChar('"'+nazov_prog+'" "'+GetCurrentDir+'\'+nazov+'"'),1);
end;

  {-- zobrazi temy pomocnika --}
procedure TemyPomocnika;
begin
  WinExec(PChar('explorer "'+GetCurrentDir+'\help\index.html'+'"'),1);
end;

  {-- zobrazi informacie o programe --}
procedure OPrograme;
begin
  QuestionDlg(txOPrograme,'EditWebs - NON-WYSIWYG Web Editor'#13
  +txVerzia+' 1.0'#13
  +'http://sulo.stary-gympel.sk/editwebs/'#13
  +' 2005-2006, Mat Sulr',mtInformation,[MR_OKEY,txTlOK],0);
end;

