  {-------------------------------------------------------------------------}
  {------------------------ WEBOVE NASTROJE --------------------------------}

{*
 * EditWebs is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EditWebs is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with EditWebs. If not, see <http://www.gnu.org/licenses/>.
 *}

  {-- vypise subory v adresari --}
procedure VypisAdresar(adr: string);
var
  VysledkyHladania: TSearchRec;
begin
  F.lbxSubory.Items.Clear;
  if FindFirst(adr+'\*',faAnyFile and not faSysFile and not faHidden,
   VysledkyHladania) = 0 then begin // ak bol najdeny aspon 1 subor
    repeat
      if VysledkyHladania.Name <> '.' then
        F.lbxSubory.Items.Add(VysledkyHladania.Name);
    until FindNext(VysledkyHladania) <> 0; // kym sa este nejaky subor nachadza
    F.lbxSubory.ItemIndex := 0;
  end;
  if F.lbxSubory.Items.Count = 0 then begin
    F.cmbDisky.ItemIndex := F.cmbDisky.Items.IndexOf(ExtractFileDrive(GetCurrentDir)+'\');
    VypisAdresar(F.cmbDisky.Items[F.cmbDisky.ItemIndex]);
  end;
end;

  {-- nacita zoznam diskov a suborov --}
procedure NacitatDisky;
var
  r: LongWord;
  disky: array[0..128] of char;
  disk: PChar;
begin
  r := GetLogicalDriveStrings(SizeOf(disky),disky);
  disk := disky;
  while disk^ <> #0 do begin
    F.cmbDisky.Items.Add(disk);
    Inc(disk,4);
  end;
  F.cmbDisky.ItemIndex := F.cmbDisky.Items.IndexOf(ExtractFileDrive(GetCurrentDir)+'\');
  VypisAdresar(F.cmbDisky.Items[F.cmbDisky.ItemIndex]);
  AktualnyAdresar := F.cmbDisky.Items[F.cmbDisky.ItemIndex];
end;

  {-- zmeni aktualny disk --}
procedure ZmenitDisk;
begin
  VypisAdresar(F.cmbDisky.Items[F.cmbDisky.ItemIndex]);
  AktualnyAdresar := F.cmbDisky.Items[F.cmbDisky.ItemIndex];
end;

  {-- otvori adresar/subor --}
procedure OtvoritAdrSubor;
var
  nazov: string;
begin
  nazov := F.lbxSubory.Items[F.lbxSubory.ItemIndex];
  if DirectoryExists(AktualnyAdresar+nazov) then begin
    if nazov = '..' then
      AktualnyAdresar := ExtractFilePath(ExcludeTrailingBackslash(AktualnyAdresar))
    else
      AktualnyAdresar := AktualnyAdresar+nazov+'\';
    VypisAdresar(AktualnyAdresar);
  end
  else
    OtvoritSubor(AktualnyAdresar+nazov);
end;

  {-- zisti nazvu tagu bez inych znakov --}
function ZistiNazovTagu(hodnota_tagu: string): string;
var
  docas_text: string;
begin
  if Pos('>',hodnota_tagu) > 0 then
    docas_text := LeftStr(hodnota_tagu,Pos('>',hodnota_tagu)-1);
  if Pos('/',docas_text) > 0 then
    docas_text := LeftStr(docas_text,Pos('/',docas_text)-1);
  if Pos(' ',docas_text) > 0 then
    docas_text := LeftStr(docas_text,Pos(' ',docas_text)-1);
  if Pos('<',docas_text) > 0 then
    docas_text := RightStr(docas_text,Length(docas_text)-1);
  Result := docas_text;
end;

  {-- priradi tagy k (x)html verzii a nacita css selektory --}
procedure ZmenaHTMLVerzie;
var
  c: integer;
begin
  HTMLIniSubor := TIniFile.Create('web\'+F.cmbHTMLVerzie.Text+KONC_WEB_NASTROJA);
  HTMLIniSubor.ReadSections(F.lbxHTMLTagy.Items);
  F.cbxHTMLAtributy.Clear;
  if F.cmbHTMLVerzie.Text = 'XHTML 1.0 Strict' then begin
    F.cbHTMLVelkePismena.Checked := false;
    F.cbHTMLVelkePismena.Enabled := false;
  end
  else
    F.cbHTMLVelkePismena.Enabled := true;
  F.cmbCSSNovy.Clear;
  for c := 0 to F.lbxHTMLTagy.Items.Count-1 do begin
    F.cmbCSSNovy.Items.Add(ZistiNazovTagu(F.lbxHTMLTagy.Items[c]));
  end;
end;

  {-- priradi html atributy k tagom --}
procedure HTMLTagyAtributy;
var
  htmlTag: string;
  c: integer;
begin
  if F.lbxHTMLTagy.ItemIndex > -1 then begin
    htmlTag := F.lbxHTMLTagy.Items[F.lbxHTMLTagy.ItemIndex]; // zistenie tagu
    HTMLIniSubor.ReadSection(htmlTag,F.cbxHTMLAtributy.Items);
    F.cbxHTMLAtributy.Items.Text := StringReplace(F.cbxHTMLAtributy.Items.Text,'','=""',[rfReplaceAll]);
    for c := 0 to F.cbxHTMLAtributy.Items.Count-1 do begin
      if HTMLIniSubor.ReadString(htmlTag,StringReplace(F.cbxHTMLAtributy.Items[c],'=""','',[]),'') = '' then
        F.cbxHTMLAtributy.Checked[c] := true;
    end;
  end;
end;

  {-- vlozi tag + atribut do synmema --}
procedure VlozitHTMLTagAtr;
var
  htmlTag, lava_cast, prava_cast, text_kodu: string;
  atributy: string = '';
  c: integer;
begin
  if F.lbxHTMLTagy.ItemIndex > -1 then // osetrenie chyby - ak uz bol vybraty tag
    htmlTag := F.lbxHTMLTagy.Items[F.lbxHTMLTagy.ItemIndex]; // zistenie tagu
  if Pos('>',htmlTag) > 0 then
    lava_cast := LeftStr(htmlTag,Pos('>',htmlTag)-1);
  if Pos('/',lava_cast) > 0 then
    lava_cast := LeftStr(lava_cast,Pos('/',lava_cast)-1); // lava cast
  if Pos('/>',htmlTag) > 0 then
    prava_cast := RightStr(htmlTag,Length(htmlTag)-Pos('/>',htmlTag)+1);
  if (Pos('>',htmlTag) > 0) and (Pos('/>',htmlTag) = 0) then
    prava_cast := RightStr(htmlTag,Length(htmlTag)-Pos('>',htmlTag)+1); // prava cast
  for c:=0 to F.cbxHTMLAtributy.Items.Count-1 do begin
    if F.cbxHTMLAtributy.Checked[c] then
      atributy := atributy+' '+F.cbxHTMLAtributy.Items[c];
  end; // zistovanie zaskrtnutych atributov
  if (htmlTag <> '') or (atributy <> '') then begin // aby sa zbytocne nemenil dokument
    text_kodu := lava_cast+atributy+prava_cast;
    if F.cbHTMLVelkePismena.Checked then
      text_kodu := UpperCase(text_kodu)
    else
      text_kodu := WideLowerCase(text_kodu);
    Pis(text_kodu);
    F.Kod.CaretX := F.Kod.CaretX-Pos('>',RightStr(text_kodu,Length(text_kodu)-Pos('>',text_kodu)));
  end;
end;

  {-- zapise vybranie html atributu do suboru --}
procedure ZapisVyberHTMLAtributu;
var
  htmlTag, htmlAtribut: string;
begin
  if F.cbxHTMLAtributy.ItemIndex > -1 then begin
    htmlTag := F.lbxHTMLTagy.Items[F.lbxHTMLTagy.ItemIndex]; // zistenie tagu
    htmlAtribut := StringReplace(F.cbxHTMLAtributy.Items[F.cbxHTMLAtributy.ItemIndex],'=""','',[]);
    if F.cbxHTMLAtributy.Checked[F.cbxHTMLAtributy.ItemIndex] then
      HTMLIniSubor.WriteString(htmlTag,htmlAtribut,'')
    else
      HTMlIniSubor.WriteString(htmlTag,htmlAtribut,'');
  end;
end;

  {-- nacita css pseudoelementy a vlastnosti --}
procedure ZmenaCSSVerzie;
begin
  F.cmbCSSPseudo.Text := '';
  CSSIniSubor := TIniFile.Create('web\'+F.cmbCSSVerzie.Text+KONC_WEB_NASTROJA);
  CSSIniSubor.ReadSection('pseudo',F.cmbCSSPseudo.Items);
  CSSIniSubor.ReadSection('vlastnosti',F.lbxCSSVlastnosti.Items);
end;

  {-- zapise css pseudoelement+selektor/triedu/identifikator do synmema --}
procedure ZapisCSS(znak: string);
begin
  Pis(znak+F.cmbCSSNovy.Text+F.cmbCSSPseudo.Text+'{'#13#13'}');
  F.Kod.CaretY := F.Kod.CaretY-1;
end;

  {-- priradi hodnoty k css vlastnosti --}
procedure CSSVlastnostiHodnoty;
var
  hodnoty: string;
begin
  if F.lbxCSSVlastnosti.ItemIndex > -1 then begin
    hodnoty := CSSIniSubor.ReadString('vlastnosti',F.lbxCSSVlastnosti.Items[F.lbxCSSVlastnosti.ItemIndex],'');
    F.cmbCSSHodnoty.Items.Text := StringReplace(hodnoty,'|',#13,[rfReplaceAll]);
  end;
end;

  {-- zapise css vlastnosti+hodnoty do synmema --}
procedure VlozitCSS;
var
  text_kodu: string;
begin
  if F.lbxCSSVlastnosti.ItemIndex > -1 then begin
    text_kodu := F.lbxCSSVlastnosti.Items[F.lbxCSSVlastnosti.ItemIndex]+' '+F.cmbCSSHodnoty.Text+';';
    Pis(text_kodu);
    if F.cmbCSSHodnoty.Text = '' then
      F.Kod.CaretX := F.Kod.CaretX-1;
    if Pos('*',text_kodu) > 0 then
      F.Kod.CaretX := F.Kod.CaretX-Length(text_kodu)+Pos('*',text_kodu)-1;
  end;
end;

  {-- nacita strom scriptov --}
procedure ZmenaVerzieScriptov;
begin
  F.trvScripty.LoadFromFile('web\'+F.cmbScriptyVerzie.Text+KONC_WEB_NASTROJA);
end;

  {-- vlozi vybrany text zo stromu scriptov do synmema --}
procedure VlozitZoStromuScriptov;
begin
  if (F.trvScripty.Selected <> nil)
  and (F.trvScripty.Selected.Level > 0)
  and (F.trvScripty.Selected.IsVisible) then
    Pis(F.trvScripty.Selected.Text);
end;

  {-- nacita strom php podla verzie --}
procedure ZmenaPHPverzie;
begin
  F.trvPHP.LoadFromFile('web\'+F.cmbPHPVerzie.Text+KONC_WEB_NASTROJA);
end;

  {-- vlozi text zo stromu php do synmema --}
procedure VlozitPHP;
begin
  if (F.trvPHP.Selected <> nil)
  and (F.trvPHP.Selected.Level > 0)
  and (F.trvPHP.Selected.IsVisible)
  and not ((F.trvPHP.Selected.Level = 1) and (F.trvPHP.Selected.Parent.Text = 'Functions')) then
    Pis(F.trvPHP.Selected.Text);
end;

  {-- nacita mapu znakov --}
procedure NacitatZnaky;
var
  c: byte;
  polozka: TListItem;
begin
  for c := 33 to 255 do begin
    polozka := F.lsvZnaky.Items.Add;
    polozka.Caption := IntToStr(c);
    polozka.SubItems.Add(chr(c));
  end;
end;

  {-- vlozi vybrany znak z mapy znakov --}
procedure VlozitZnak;
begin
  if F.lsvZnaky.Selected <> nil then
    Pis(F.lsvZnaky.Selected.SubItems[0]);
end;

  {-- vlozi entitu vybraneho znaku z mapy znakov --}
procedure VlozitEntitu;
begin
  if F.lsvZnaky.Selected <> nil then
    Pis('&#'+F.lsvZnaky.Selected.Caption+';');
end;

  {-- nacita paletu z vybraneho suboru --}
procedure NacitatPaletuZoSuboru;
begin
  if F.dlgNacitatPaletu.Execute then
    F.imgFarby.Picture.LoadFromFile(F.dlgNacitatPaletu.FileName);
end;

  {-- nacita paletu z obrazka --}
procedure NacitatPaletu;
begin
  if FileExists('palettes\default.jpg') then
    F.imgFarby.Picture.LoadFromFile('palettes\default.jpg');
end;

  {-- zmeni vybranu farbu podla farby v zozname --}
procedure VybratFarbuZoZoznamu;
begin
  F.clbFarba.ButtonColor := F.clxFarba.Colors[F.clxFarba.ItemIndex];
end;

  {-- zmeni vybranu farbu podla kliknutia na paletu --}
procedure VybratFarbuZPalety(x,y: integer);
var
  farba: TColor;
begin
  farba := F.imgFarby.Canvas.Pixels[x,y];
  if ColorToString(farba) = 'clForeground' then
    F.clbFarba.ButtonColor := clWhite
  else
    F.clbFarba.ButtonColor := farba;
end;

  {-- vlozi vybranu farbu --}
procedure VlozitFarbu;
var
  farba: TColor;
begin
  farba := F.clbFarba.ButtonColor;
  Pis('#'+IntToHex(Red(farba),2)+IntToHex(Green(farba),2)+IntToHex(Blue(farba),2));
end;

